############################################################################
#
# userbase_prefs.cgi
# Version: 3.18-t02
#
# NOTE: there are many preferences ("prefs") in this file, but virtually all
# of them are *optional* and can be left at their default values.  The app
# will tell you (via web browser) about any prefs that absolutely must be 
# set or adjusted.  It's best to start by reading the FAQ rather than trying
# to read through all the prefs right away:
#
# 	http://encodable.com/userbase/faq
#
############################################################################



############################################################################
# Database settings: to get UserBase running, the one configuration item
# that you absolutely must adjust is the database settings.  The hostname
# may be left blank (which defaults to 'localhost') on many servers, but the
# other three settings -- database name, username, and password -- must be
# specified.
#
# The database_username that you specify must have full MySQL privileges on
# the database_name that you specify.
#
# Enter your settings on the right-hand side of the equal signs below, for
# example:
#
#	$PREF{database_password}		= 'my-secret-word';
#
$PREF{database_hostname}				= '';
$PREF{database_name}					= '';
$PREF{database_username}				= '';
$PREF{database_password}				= '';
#
# The following settings usually don't need to be adjusted.  If you're
# using PostgreSQL instead of MySQL, then just make sure you have the
# DBD::Pg Perl module installed, then change the dbi_connection_string
# to "dbi:Pg:dbname=%%dbname%%".  Or if your mysql.sock file is in a
# non-standard location, you can specify that in the connection string:
#
#	dbi:mysql:%%dbname%%;mysql_socket=/var/mysql/mysql.sock
#
$PREF{dbi_connection_string}				= "dbi:mysql:%%dbname%%";



############################################################################
# Options for the various database-viewer pages/tables/logs/etc.
#
# You should never need to enable force_database_table_checks unless you've
# manually deleted or modified your database tables (not the data within the
# tables, but the table structures themselves).
#
$PREF{database_file_picker_file_icon}			= '%PREF{app_images_url}/db_file_icon.gif';
$PREF{database_file_picker_default_allowed_file_types}	= 'txt|doc|pdf|jpg|jpeg|png|bmp|gif|mp3|mpg|avi';
$PREF{force_database_table_checks}			= 'no';



############################################################################
# We'll detect your server's document-root automatically, but on some
# servers you may need to uncomment this and specify it manually.  IIS users
# may need to set it like this:
#
#	$PREF{DOCROOT} = 'c:\inetpub\wwwroot';
#
#$PREF{DOCROOT}						= $ENV{DOCUMENT_ROOT};



############################################################################
# If you're running an HTTPS server, and you want UserBase to always
# use secure links, then uncomment $PREF{protoprefix} and change it to
# https://.  But note that this only affects links generated by UserBase
# itself; it doesn't prevent your users from typing http:// (without the "s")
# into their address bar.  For that, you'll need to enable $PREF{force_https}.
# If you do have an HTTPS server, then you should definitely enable the
# $PREF{require_encrypted_connection_for_login_cookie} setting.
# 
#$PREF{protoprefix}					= 'http://';
$PREF{force_https}					= 'no';
$PREF{require_encrypted_connection_for_login_cookie}	= 'no';



############################################################################
# If you've renamed UserBase's top-level "login" folder to something
# else, then adjust this setting to match your new name/location for it.
# But in most cases that folder shouldn't be moved, and this setting
# shouldn't be changed.
#
$PREF{app_base_folder}					= '/login';



############################################################################
# This is where UserBase stores any data files it needs to use.  It must
# be world-readable and world-writable, aka "chmod a+rwx" or "chmod 0777".
# On most servers this will be in the DOCROOT, in which case we'll prepend
# your DOCROOT to whatever you set datadir to.  If for some reason you want
# to specify it with an absolute path, or a path that's relative to the
# current directory instead of the DOCROOT, then set the  ...is_in_docroot
# PREF to no.
#
$PREF{datadir}						= 'encdata';
$PREF{datadir_is_in_docroot}				= 'no';



############################################################################
# Specify the URL to UserBase on your server. The default value is:
#
#	$PREF{login_url}		= $ENV{SCRIPT_NAME};
#
# If you have a short login URL set up on your server (see UserBase
# homepage for instructions), then use that instead:
#
#	$PREF{login_url}		= '/login/';
#
$PREF{login_url}					= $ENV{SCRIPT_NAME};



############################################################################
# This is where you install UserBase's images (icons, backgrounds, etc).
# It must be within your website's document root.  It must not end with
# a slash.
#
$PREF{app_images_url}					= '%PREF{app_base_folder}/images';



############################################################################
# Email options.  The email addresses specified here must be of the format
# 'foo@bar.com', or 'Your Name <foo@bar.com>', however some servers may have
# trouble with the latter format, preventing the script from sending its
# emails.
#
$PREF{webmaster_email_address}				= 'webmaster@example.com';   # Recipient for admin approval of new signups, etc. Must be a single address.
$PREF{app_email_address}				= 'userbase@example.com';   # This is the sender or "From:" address on most script-based emails. Must be a single address.
$PREF{smtp_server}					= 'localhost:25'; # port is usually 25 or 587.
$PREF{path_to_sendmail}					= '/usr/sbin/sendmail';   # try 'C:/xampp/sendmail' if you're using XAMPP.
$PREF{smtp_auth_username}				= '';
$PREF{smtp_auth_password}				= '';
$PREF{treat_sendmail_closing_error_as_failed_delivery}	= 'yes';   # should be 'yes' except on some servers where sendmail is flaky.
$PREF{log_all_sent_mail}				= 'yes';
$PREF{log_message_bodies_in_sent_mail_log}		= 'no';   # WARNING: potential security threat if enabled, since some email bodies contain plaintext passwords.
$PREF{max_records_to_keep_in_sent_mail_log}		= 1000;   # any number, or 'all' to disable auto-delete.



$PREF{email_wrapper_head} = qq`
<html><!-- using all inline styling as required by some email clients, e.g. gmail -->
<body style="background: #efefef; margin: 0; padding: 20px; text-align: center; font: 9pt sans-serif;">

<table id="wrapper" style="font: 9pt sans-serif; margin: 20px auto; width: 600px; border: 1px solid #777; padding: 0; text-align: left; border-collapse: collapse;">

<tr><td id="head" style="background: #569be9; margin: 0; padding: 10px; border-bottom: 1px solid #777; text-align: center;">

<h1 id="title" style="font-size: 28pt; color: #fff; text-shadow: 1px 1px 1px #333; margin: 2px 2px 2px 0;">%PREF{title_text}</h1>
<!--<h3 id="subtitle" style="font-size: 14pt; color: #fff; text-shadow: 1px 1px 1px #333; margin: 2px;">%%subtitle%%</h3>-->
</tr></td><!-- end head -->

<tr><td id="main" style="background: #ffffff; margin: 0; padding: 10px; border-bottom: 1px solid #777;">
`;



$PREF{email_wrapper_foot} = qq`
</tr></td><!-- end main -->

<tr><td id="foot" style="background: #d5d5d5; margin: 0; padding: 10px; border-bottom: 0px solid #888; font: bold 8pt sans-serif; text-align: center;">
Delivered by <a href="%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{here}" style="color: #57c">$ENV{HTTP_HOST}</a> | Powered by <a href="http://encodable.com/userbase/" style="color: #57c">UserBase</a>
</tr></td><!-- end foot -->

</table><!-- end wrapper -->
</body>
</html>
`;



############################################################################
# Specify title and options.
#
$PREF{title}						= 'UserBase';
$PREF{title_text}					= 'UserBase';   # only text; no HTML, images, etc.
$PREF{titlebar_title}					= 'UserBase - %%subtitle%% - %ENV{HTTP_HOST}';



############################################################################
# DirLock: password-protect whole directories/folders:
#
# [Note: you don't have to configure this here; you can do it via browser
# instead.  Log into UserBase with your admin account and click on DirLock.]
#
# To password-protect a whole directory without using PHP and without having
# to edit any of the files in the directory, use these settings, and see
# this page for instructions:
#
#	http://encodable.com/userbase/#password-protect-directory
#
# You can create multiple protected directories by copying these prefs to new
# ones named with _02, _03, etc, and copying the "protected" directory -- be
# sure to update the .htaccess file within each protected directory and adjust
# the ?pdir=01 value to match the number in the corresponding prefs here.
# The _ignore_file_extensions setting allows you to use whatever file
# extensions you want to on your URLs, and UserBase will simply ignore the
# extensions and use the base filename to figure out which actual file/page
# from the disk to use.  For the allowed_to_access settings, a visitor only
# needs to match one -- either the users list, or the groups list -- to be
# granted access.  The filetypes_to_parse setting will cause UserBase to read
# and do variable substitution into the contents of the specified file types
# (e.g. if you put $PREF{logged_in_username} within your page, UserBase will
# replace that with the username of the logged-in user).  If you aren't going
# to put any such variables into your pages anyway, then you can set this to
# null, which may give a slight performance boost.  Of course don't put any
# non-text types (e.g. jpg, zip, etc) into this setting in any case.
#
$PREF{protected_directory_01}				= '%PREF{DOCROOT}/protected';
$PREF{protected_directory_01_ignore_file_extensions}	= 'yes';
$PREF{protected_directory_01_filetypes_to_parse}	= 'htm,html';   # comma-separated list of extensions.
$PREF{users_allowed_to_access_protected_directory_01}	= 'someone';   # comma-separated list of usernames.
$PREF{groups_allowed_to_access_protected_directory_01}	= 'member';   # comma-separated list of groups.
$PREF{protected_directory_default_index_filename}	= 'index.html';   # page to show when a visitor accesses the directory with no filename.



############################################################################
# BasicLock: for servers with limited capabilities:
#
# If you want to password-protect pages on your site, but your server
# doesn't support PHP, or it supports PHP but has the PHP functions exec()
# and/or include() disabled, then you can protect your pages by putting them
# into the directory specified here.  See the following page for full
# instructions: 
#
#	http://encodable.com/userbase/#password-protect-without-php
#
$PREF{protected_pages_directory}			= '%PREF{DOCROOT}/protected-pages-go-here';



############################################################################
# RefLock: not recommended (use DirLock or FileChucker instead)
#
# This older password-protection feature can be used to protect a directory
# and show a file listing.  It requires PHP and the .htaccess commands
# RewriteEngine, RewriteRule, and RewriteCond.
# 
# RefLock has the caveat that it's based on the HTTP_REFERER variable sent
# by your visitors' browsers.  It's possible for malicious and relatively
# advanced users to spoof this variable, so you shouldn't use this method
# if the files that you're protecting are especially sensitive or
# confidential in nature.  And by this method, any link on your own website
# pointing to a file within the protected directory will bypass the
# protection; this is necessary so that the protected directory list itself
# can function, but it also  means that you shouldn't create any other links
# to the files in the protected directory, unless you're OK with such links
# always working regardless of whether the user is logged in to UserBase.
#
# For more secure and advanced whole-directory protection without these
# caveats, you should use UserBase in conjunction with FileChucker:
# http://encodable.com/filechucker/ -- then enable FileChucker's userdir
# and/or custom folder permissions features, or just set the whole app to
# members-only access, etc, as explained in these FAQ items:
#
# 	http://encodable.com/filechucker/faq/#password
# 	http://encodable.com/filechucker/faq/#private
# 	http://encodable.com/filechucker/faq/#custperms
# 
# If you still want to use RefLock, download this file:
#
# 	http://encodable.com/userbase/password-protect-folder.zip
#
# Unzip that file, which will give you 2 files: .htaccess and index.php. Edit
# the .htaccess file and replace "yoursite\.com" with your actual domain name
# (be sure to keep the slash), and then on the REQUEST_URI line, adjust the
# list of file extensions to protect. Then just upload these 2 files into any
# directory on your website that you want to protect.



############################################################################
# In order to password-protect whole directories, UserBase needs to return
# the correct MIME type for any requested document.  It will try to use the
# MIME::Types Perl module to do this automatically, but if that's not
# available on your server, or you enable $PREF{dont_use_the_mime_types_module},
# then UserBase will fall back to these static MIME type definitions.
#
$PREF{dont_use_the_mime_types_module}			= 'no';
$PREF{mimetype_for_avi}					= 'video/x-msvideo';
$PREF{mimetype_for_bmp}					= 'image/x-bmp';
$PREF{mimetype_for_doc}					= 'application/x-msword';
$PREF{mimetype_for_flv}					= 'video/x-flv';
$PREF{mimetype_for_gif}					= 'image/gif';
$PREF{mimetype_for_htm}					= 'text/html';
$PREF{mimetype_for_html}				= 'text/html';
$PREF{mimetype_for_jpg}					= 'image/jpeg';
$PREF{mimetype_for_jpeg}				= 'image/jpeg';
$PREF{mimetype_for_mov}					= 'video/quicktime';
$PREF{mimetype_for_mpg}					= 'video/mpeg';
$PREF{mimetype_for_mpeg}				= 'video/mpeg';
$PREF{mimetype_for_mp3}					= 'audio/mpeg';
$PREF{mimetype_for_mp4}					= 'video/mp4';
$PREF{mimetype_for_pdf}					= 'application/pdf';
$PREF{mimetype_for_php}					= 'text/html';
$PREF{mimetype_for_png}					= 'image/png';
$PREF{mimetype_for_tif}					= 'image/tiff';
$PREF{mimetype_for_tiff}				= 'image/tiff';
$PREF{mimetype_for_txt}					= 'text/plain';
$PREF{mimetype_for_xls}					= 'application/vnd.ms-excel';
$PREF{mimetype_for_zip}					= 'application/zip';



############################################################################
# In addition to mimetypes (above), you can specify the disposition for the
# files that UserBase protects.  This is typically either "inline" or 
# "attachment", where inline means displayed by the browser (for example
# image files can be displayed directly in the browser), while attachment
# means that the browser will offer the file as a download instead of
# displaying it itself.  Browsers have default dispositions for most common
# file types, but you can override those by adding prefs here.
#
# You can also specify different dispositions on a per-directory basis,
# by creating prefs like this:
#
#	$PREF{protected_directory_01_disposition_for_pdf} = 'inline';
#
# A per-directory rule like that will override a $PREF{disposition_for_foo}
# rule when both are set for the same filetype.
# 
$PREF{disposition_for_jpg}				= 'inline';
$PREF{disposition_for_pdf}				= 'attachment';
$PREF{disposition_for_txt}				= 'inline';



############################################################################
# If you want your date/time values to be different than the date on your
# server, you can set an offset here.
#
$PREF{time_offset}					= -0; # in hours; can include negative sign.



############################################################################
# Set options for various permissible actions.
#
# The prefs that start with "groups_" must be lists of groupnames separated
# by spaces and/or commas.  In addition to your actual existing groupnames
# you can use the special groupnames "self", "public", and "member" here.
#
# The reserved groupname "self" indicates that permission should be granted
# if the user trying to perform the action is the same user who will be 
# affected by it -- for example each user should be allowed to modify their 
# own personal info (real name, email address, etc) but not the personal 
# info of other users.  Note that the "self" group does not apply to all
# actions.
#
# The special groupname "public" automatically includes all users, even
# those who do not have an account, i.e. any old internet passer-by.  You
# can change the name of this group, but if you do then you'll have to
# manually create the new group.
#
# The special groupname "member" automatically includes all users who do
# have an account in the system; it does NOT include strangers.  You
# can change the name of this group, but if you do then you'll have to
# manually create the new group.
#
# For each of the groups_allowed_to_action settings here, you can also 
# create a new setting called groups_not_allowed_to_action, which works
# the same way but in reverse: it explicitly disallows the action.
#
# In the settings below, "user" refers to any non-admin account.
#
# NOTE THAT THE DEFAULT SETTINGS ARE CORRECT FOR MOST SITUATIONS.
#
$PREF{groups_allowed_to_do_app_administration}			= 'admin';
#
$PREF{groups_allowed_to_create_user_accounts}			= 'admin'; # but see below for visitor sign-ups.
$PREF{groups_allowed_to_create_admin_accounts}			= 'admin';
$PREF{groups_allowed_to_create_groups}				= 'admin';
#
$PREF{groups_allowed_to_edit_user_info}				= 'admin,self';
$PREF{groups_allowed_to_edit_admin_info}			= 'admin';
$PREF{groups_allowed_to_edit_group_info}			= 'admin';
#
$PREF{groups_allowed_to_delete_user_accounts}			= 'admin';
$PREF{groups_allowed_to_delete_admin_accounts}			= 'admin';
$PREF{groups_allowed_to_delete_groups}				= 'admin';
#
$PREF{groups_allowed_to_import_accounts}			= 'admin';
$PREF{groups_allowed_to_export_accounts}			= 'admin';
$PREF{groups_allowed_to_manage_custom_fields}			= 'admin';
$PREF{groups_allowed_to_manage_field_sections}			= 'admin';
$PREF{groups_allowed_to_change_group_memberships}		= 'admin';
$PREF{groups_allowed_to_manage_account_locks}			= 'admin';
$PREF{groups_allowed_to_force_password_changes}			= 'admin';
$PREF{groups_allowed_to_view_password_activity_log}		= 'admin';
$PREF{groups_allowed_to_edit_password_activity_log}		= 'admin';
$PREF{groups_allowed_to_delete_password_activity_log_records}	= 'admin';
$PREF{groups_allowed_to_view_userinfo_updates}			= 'admin';
$PREF{groups_allowed_to_edit_userinfo_updates}			= 'admin';
$PREF{groups_allowed_to_delete_userinfo_updates_records}	= 'admin';
$PREF{groups_allowed_to_manage_pagelock_pages}			= 'admin';
$PREF{groups_allowed_to_manage_dirlock_dirs}			= 'admin';
#
$PREF{groups_allowed_to_view_all_accounts}			= 'admin';
$PREF{groups_allowed_to_view_all_groups}			= 'admin';
$PREF{groups_allowed_to_see_groups_on_user_form}		= 'admin';
$PREF{groups_allowed_to_see_full_grouplist_on_user_form}	= 'admin';
$PREF{groups_allowed_to_manage_group_log}			= 'admin';
$PREF{groups_allowed_to_view_logins_log}			= 'admin';
$PREF{groups_allowed_to_edit_logins_log}			= 'admin';
$PREF{groups_allowed_to_delete_logins_log_records}		= 'admin';
$PREF{groups_allowed_to_view_failed_logins_log}			= 'admin';
$PREF{groups_allowed_to_edit_failed_logins_log}			= 'admin';
$PREF{groups_allowed_to_delete_failed_logins_log_records}	= 'admin';
$PREF{groups_allowed_to_view_promo_db}				= 'admin';
$PREF{groups_allowed_to_create_promos}				= 'admin';
$PREF{groups_allowed_to_edit_promo_db}				= 'admin';
$PREF{groups_allowed_to_delete_promos}				= 'admin';
#
$PREF{groups_allowed_to_edit_all_mainmenus}			= 'admin';
$PREF{groups_allowed_to_edit_admin_mainmenu}			= 'admin';
$PREF{groups_allowed_to_edit_member_mainmenu}			= 'admin';
#
$PREF{groups_allowed_to_view_event_calendar}			= 'member';
$PREF{groups_allowed_to_edit_event_calendar}			= 'member';
$PREF{groups_allowed_to_view_all_user_event_calendars}		= 'admin';
$PREF{groups_allowed_to_edit_all_user_event_calendars}		= 'admin';
#
$PREF{groups_allowed_to_view_member_directory}			= 'admin';
$PREF{groups_allowed_to_view_profile_pages}			= 'admin,self';
$PREF{groups_allowed_to_change_profile_image}			= 'member';
#
$PREF{groups_allowed_to_view_own_payments}			= 'member';
$PREF{groups_allowed_to_view_all_payments}			= 'admin';
$PREF{groups_allowed_to_create_payments}			= '';   # should be '' except for debugging.
$PREF{groups_allowed_to_edit_payments}				= 'admin';
$PREF{groups_allowed_to_delete_payments}			= 'admin';
#
$PREF{groups_allowed_to_view_sent_mail_log}			= 'admin';
$PREF{groups_allowed_to_edit_sent_mail_log}			= '';   # should be '' except for debugging.



############################################################################
# You can also specify who is allowed to edit which user info fields on a
# per-field basis.  A pref for each of the built-in fields is listed here by
# default, and you can add new ones for any custom fields that you create.
# Of course this does not override any stronger protections that also apply;
# for example setting one of these prefs to 'member' means only that members
# can edit *their own* info, not other users' info.  Also note that
# usernames in particular are never editable by anyone by default, because
# of the $PREF{usernames_are_immutable_once_created} setting, which you
# should not disable.
#
$PREF{groups_allowed_to_edit_username_field}			= ''; # never editable by default.
$PREF{groups_allowed_to_edit_realname_field}			= 'member';
$PREF{groups_allowed_to_edit_password_field}			= 'member';
$PREF{groups_allowed_to_edit_email_field}			= 'member';



############################################################################
# Choose whether visitors can sign up for their own accounts.  If so, you
# can also require email verification for new signups, and/or administrator
# approval for them.  Admin approval requires the $PREF{webmaster_email_address}
# setting (above) to be a valid email address of yours.
#
# If you don't want to let visitors sign up for their own accounts, you (as
# the administrator) can always create new accounts manually, through the
# "Manage Users" page, and then distribute the logins to your users yourself.
#
$PREF{visitors_can_sign_up_for_their_own_accounts}	= 'yes';
$PREF{require_email_verification_for_new_signups}	= 'yes';
$PREF{verification_email_format}			= 'text'; # 'html' or 'text'
$PREF{verification_email_subject}			= qq`Verify your new account on $ENV{HTTP_HOST}`;
$PREF{verification_email_template}			= qq`Hello,\n\nThanks for creating an account at $ENV{HTTP_HOST}.\n\nTo verify your email address, visit the following page:\n\n%%link%%\n\nThanks,\n%PREF{title_text}\n`;
$PREF{email_verified_pending_template}			= qq`<p>Thanks for verifying your email address.&nbsp; This site requires administrator approval for <br />new accounts, so your account will be activated if and when the administrator approves it.</p>\n`;
$PREF{email_verified_active_template}			= qq`<p>Thanks for verifying your email address.&nbsp; Your account is now active.</p><p>You can <a href="%%login_url%%">log in here.</a></p>\n`;
#
$PREF{user_must_agree_to_terms_on_signup}		= 'no';
$PREF{terms_unchecked_error_message}			= "You must check the Terms of Use checkbox to indicate your acceptance of the terms.";
#
$PREF{require_admin_approval_for_new_signups}		= 'yes';
$PREF{admin_approval_email_recipient}			= '%PREF{webmaster_email_address}'; # one or more addresses, comma-separated.
$PREF{admin_approval_email_format}			= 'text'; # 'html' or 'text'
$PREF{admin_approval_email_subject}			= qq`New account '%%username%%' requires approval on $ENV{HTTP_HOST}`;
$PREF{admin_approval_email_template}			= qq`Hello,\n\nA new account named '%%username%%' has been created on $ENV{HTTP_HOST},\nand it requires your approval.\n\nVisit the following address to approve or delete this new account:\n\n%%approval_url%%\n\nSigned,\n%PREF{title_text}\n`;
$PREF{account_activated_email_subject}			= qq`Account activated on $ENV{HTTP_HOST}`;
$PREF{account_activated_email_template}			= qq`Hello,\n\nYour new account with username '%%username%%' has been approved and activated on $ENV{HTTP_HOST}.\n\nThanks,\n%PREF{title_text}\n`;
#
$PREF{notify_admin_of_new_signups}			= 'yes';
$PREF{admin_notification_email_recipients}		= '%PREF{webmaster_email_address}'; # one or more addresses, comma-separated.
$PREF{admin_notification_email_format}			= 'text'; # 'html' or 'text'
$PREF{admin_notification_email_subject}			= qq`New account '%%username%%' created on $ENV{HTTP_HOST}`;
$PREF{admin_notification_email_template}		= qq`Hello,\n\nA new account has been created on $ENV{HTTP_HOST}.\nHere are the details:\n\n\n%%user_info_fields%%\nSigned,\n%PREF{title_text}\n`;
$PREF{admin_notification_email_field_template}		= qq`%%fieldname%%: %%fieldvalue%%\n\n`;
#
$PREF{send_welcome_email_when_user_completes_signup}	= 'no';
$PREF{send_welcome_email_when_admin_creates_an_account} = 'no';
$PREF{send_welcome_email_to_accounts_created_via_csv_import} = 'no';
$PREF{welcome_email_format}				= 'html'; # 'html' or 'text'
$PREF{welcome_email_subject}				= qq`Welcome to $ENV{HTTP_HOST}!`;
$PREF{welcome_email_template}				= qq`$PREF{email_wrapper_head}\n<p>Hello,</p>\n\n<p>An account has been created for you on $ENV{HTTP_HOST}.</p>\n\n<p>To login to your account, use the following link, username, and password:</p>\n\n<p><a href="%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}">%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}</a>\n<br />Username: %%username%%\n<br />Password: %%password%%</p>\n\n<p>Thanks,\n<br />%PREF{title_text}</p>\n$PREF{email_wrapper_foot}\n`;
#
$PREF{send_welcome_email_to_subadmins_when_subusers_are_created_via_csv_import} = 'yes';
$PREF{welcome_email_to_subadmin_for_subuser___format}	= 'text'; # 'html' or 'text'
$PREF{welcome_email_to_subadmin_for_subuser___subject}	= qq`New sub-account "%%username%%" created on $ENV{HTTP_HOST}`;
$PREF{welcome_email_to_subadmin_for_subuser___template}	= qq`Hello,\n\nA sub-account of yours has been created on $ENV{HTTP_HOST}.\n\nThis account has the following credentials:\n\n%PREF{protoprefix}$ENV{HTTP_HOST}$PREF{login_url}\nUsername: %%username%%\nPassword: %%password%%\n\nThanks,\n%PREF{title_text}\n`;
#
$PREF{send_notification_email_to_admin_when_users_login}= 'no';
$PREF{login_notification_email_recipients}		= '%PREF{webmaster_email_address}'; # one or more addresses, comma-separated.
$PREF{login_notification_email_format}			= 'text'; # 'html' or 'text'
$PREF{login_notification_email_subject}			= qq`A user has logged in on $ENV{HTTP_HOST}`;
$PREF{login_notification_email_template}		= qq`Hello,\n\nA login has just occurred on $ENV{HTTP_HOST}.\n\nThe user who logged in is:\n\n\t%%username%% (%%realname%%)\n\nVisit the following page to view this user's information:\n\n\t%%userinfo_url%%\n\nSigned,\n%PREF{title_text}\n%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}\n`;
#
$PREF{password_reset_email_footer}			= qq`\n\n--\nThis message sent by %PREF{title_text} at:\n%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}\n`;
#
$PREF{group_membership_update_emailalert_enabled}	= 'no';
$PREF{group_membership_update_emailalert_recipients}	= 'managers'; # one or more addresses, comma-separated, and/or 'managers'.
$PREF{group_membership_update_emailalert_format}	= 'text'; # 'html' or 'text'
$PREF{group_membership_update_emailalert_added_text}	= qq`added to`;
$PREF{group_membership_update_emailalert_removed_text}	= qq`removed from`;
$PREF{group_membership_update_emailalert_subject}	= qq`User %%username%% has been %%added_to_or_removed_from%% group %%group%%`;
$PREF{group_membership_update_emailalert_body}		= qq`Hello,\n\nA group membership update has just occurred on $ENV{HTTP_HOST}:\n\nUser %%username%% (%%realname%%) has been %%added_to_or_removed_from%% group %%group%%.\n\nVisit the following page to view this user's information:\n\n\t%%userinfo_url%%\n\nSigned,\n%PREF{title_text}\n%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}\n`;
$PREF{group_membership_update_emailalert_all_body}	= qq`Hello,\n\nA group membership update has just occurred on $ENV{HTTP_HOST}:\n\nAll users have been %%added_to_or_removed_from%% group %%group%%.\n\nSigned,\n%PREF{title_text}\n%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}\n`;
#
$PREF{user_must_choose_exactly_one_group_on_signup_form}= 'no';
$PREF{user_must_choose_atleast_one_group_on_signup_form}= 'no';
$PREF{user_must_choose_exactly_one_paidgroup_on_signup_form}= 'no';
$PREF{user_must_choose_atleast_one_paidgroup_on_signup_form}= 'no';



############################################################################
# When someone visits your website and signs up for a new account, by
# default they aren't added to any groups, other than the special built-in
# groups "public" which everyone is a member of, and "members" which all
# users with accounts are members of.  If you've created other groups and
# you want new signups to automatically be added to them, you can specify
# those groups here, separated by commas.
#
$PREF{automatically_add_new_signups_to_these_groups}	= '';



############################################################################
# You can cause new sign-ups to be automatically added to different groups
# based on URL variables passed to the sign-up page.  For example, if you
# create this pref:
# 
#	$PREF{auto_add_signups_to_groups_from_url_var_01} = 'teachers';
#
# ...and then a visitor signs up using this URL:
#
#	http://yoursite.com/login/?action=signup&autogroup=01
#
# ...then that visitor will be automatically added to the "teachers" group
# when he completes his sign-up.
#
# The "01" can be any number, or any combination of letters and numbers.
# And the group ('teachers') can include multiple groups separated by
# commas.  The specified group(s) must already exist; you cannot specify
# "admin" as a group here; and you should not specify any of your paid
# groups here (if you're using those), because that would allow visitors
# to join those groups without paying.
#
$PREF{auto_add_signups_to_groups_from_url_var_01}	= '';



############################################################################
# Paid accounts feature, managed via the Manage Groups page.  Enter your
# PayPal email address into the join_paid_group_payment_recipient setting.
#
$PREF{join_paid_group_payment_recipient}		= '%PREF{webmaster_email_address}';   # Must be a single email address.
$PREF{join_paid_group_page_title}			= "Join a Paid Group";
$PREF{join_paid_group_none_available_message}		= qq`<p id="no_paid_groups_available">Sorry, there are no paid groups available to join at this time (or you've already joined them).</p>\n`;
$PREF{join_paid_group_login_message}			= qq`Please <a href="%PREF{login_url_qsready}action=signup">create an account</a> or <a href="%PREF{login_url}">login</a> first.`;
$PREF{use_checkboxes_on_join_paid_group_page}		= 'yes';

$PREF{join_paid_group_grouplist_template}		= qq`<tr class="paid_group_details %%oddeven%% %%firstlast%%"><td>%%name%%</td><td>%%desc%%</td><td>%%price_details%%</td><td>%%button_or_checkbox%%</td></tr>\n`;
$PREF{join_paid_group_grouplist_template___subadmin}	= qq`<tr class="paid_group_details %%oddeven%% %%firstlast%%"><td>%%name%%</td><td>%%desc%%</td><td>%%price_details%%</td><td>%%button_or_checkbox%%</td></tr>\n`;
$PREF{join_paid_group_subuser_template___subadmin}	= qq`<tr class="paid_group_subuser_details"><td>%%username%%</td><td><table class="paid_groups_list">%%paid_groups_list%%</table></td></tr>\n`;   # can include Custom Form Fields as variables (e.g. %%phone%%).


$PREF{join_paid_group_name_template}			= qq`Access to Group: %%group%% (%%period%%)`;
$PREF{join_paid_group_price_template___fixed}		= qq`%PREF{paid_group_currency_symbol}%%price%%%%price_label%%`;
$PREF{join_paid_group_price_template___variable}	= qq`%PREF{paid_group_currency_symbol}<input type="text" name="varprice_%%j%%" id="varprice_%%j%%" class="varprice" value="%%price%%" onchange="update_finalprice(%%j%%)" onblur="update_finalprice()" />`;
$PREF{join_paid_group_price_label___permanent}		= " (lifetime access)";
$PREF{join_paid_group_price_label___temporary}		= " %%period%%";
$PREF{join_paid_group_price_label___subscription}	= " %%period%% (recurring)";


$PREF{join_paid_group_checkboxes_label}			= '';   # optional label for the checkboxes; could be 'join', etc.
$PREF{join_paid_group_checkboxes_checkout_btn}		= qq`<input type="button" class="button submit" id="joinpaidgroup_checkout_btn" value="Checkout" onclick="submit_joinpaidgroup_checkboxes_form()" /><br /><br /><div id="joinpaidgroup_output"></div><br /><br />\n`;
$PREF{join_paid_group_checkboxes_form_end}		= qq`\n</form>\n`;


$PREF{join_paid_group_confirmation_page_title}		= qq`Thank You`;
$PREF{join_paid_group_confirmation_page_template}	= qq`
<p>Thanks for your payment.&nbsp; You will receive a notification email
shortly.&nbsp; You may <a href="%PREF{login_url}">click here</a> to login.</p>
`;

$TEXT{join_free_paid_groups_done_message}		= '<br /><br />Joined free group(s); done!&nbsp; Proceed to the <a href="%PREF{login_url}">Account Center</a>.<br /><br />';   # don't put any single-quotes within this string.

$PREF{all_payments_page_title}				= "All Payments";
$PREF{my_payments_page_title}				= "My Payments";
$PREF{paid_group_already_joined_message}		= "Already Joined";

$PREF{paid_group_currency_symbol}			= '$';
$PREF{paid_group_currency_abbreviation}			= 'USD';
$PREF{log_paypal_payment_debug_info_to_encdata_dir}	= 'yes';
$PREF{go_directly_to_PayPal_if_joinpaidgroup_page_would_only_show_one_group} = 'yes';

$PREF{send_payment_notification_emails}			= 'yes';
$PREF{payment_notification_email_recipients}		= '%PREF{webmaster_email_address}'; # one or more comma-separated addresses.
$PREF{payment_notification_email_format}		= 'text';   # 'html' or 'text'
$PREF{payment_notification_email_subject}		= qq`Payment Received from %%paypal_email%% (%%username%%)`;
$PREF{payment_notification_email_template}		= qq`Hello,\n\nYou've received a payment at http://$ENV{HTTP_HOST}/.\n\nPayment Details:\n\n--------------------------------------------------\nTransaction ID: %%txn_id%%\nTransaction type: %%txn_type_nice%%\nTransaction total: %PREF{paid_group_currency_symbol}%%transaction_cost%%\nPromo code: %%promo_code%%\nItem cost: %PREF{paid_group_currency_symbol}%%item_cost%%\nItem Number: %%item_number%%\nItem Name: %%item_name%%\nDate: %%date17%%\nPayPal date: %%paypal_date17%%\nBuyer name: %%buyer_firstname%% %%buyer_lastname%%\nPayPal email: %%paypal_email%%\nUserBase username: %%username%%\n--------------------------------------------------\n\nTo view this customer's account, visit the following page:\n\n\t%%view_account_link%%\n\nTo view your payments, visit the following page:\n\n\t%%view_payments_link%%\n\nSigned,\n%PREF{title_text}\n%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}\n`;

$PREF{send_subscription_status_emailalerts}		= 'yes';
$PREF{subscription_status_emailalert_recipients}	= '%PREF{webmaster_email_address}'; # one or more comma-separated addresses.
$PREF{subscription_status_emailalert_format}		= 'text';   # 'html' or 'text'
$PREF{subscription_status_emailalert_subject}		= qq`Subscription %%action%% for: %%paypal_email%% (%%username%%)`;
$PREF{subscription_status_emailalert_template}		= qq`Hello,\n\nA subscription %%action_full%% at http://$ENV{HTTP_HOST}/.\n\nSubscription Details:\n\n--------------------------------------------------\nItem Number: %%item_number%%\nItem Name: %%item_name%%\nDate: %%date17%%\nPayPal date: %%paypal_date17%%\nSubscriber name: %%buyer_firstname%% %%buyer_lastname%%\nPayPal email: %%paypal_email%%\nUserBase username: %%username%%\n--------------------------------------------------\n\nTo view this subscriber's account, visit the following page:\n\n\t%%view_account_link%%\n\nTo view your payments, visit the following page:\n\n\t%%view_payments_link%%\n\nSigned,\n%PREF{title_text}\n%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}\n`;



############################################################################
# When a user's membership in a temporary group (typically also a paid 
# group) expires, UserBase can send the following notification email.
#
$PREF{send_group_membership_expiration_emailalerts}	= 'yes';
$PREF{group_membership_expiration_emailalert_sender}	= '%PREF{webmaster_email_address}';
$PREF{group_membership_expiration_emailalert_format}	= 'text';   # 'html' or 'text'
$PREF{group_membership_expiration_emailalert_subject}	= qq`$ENV{HTTP_HOST}: membership in group %%group%% expired`;
$PREF{group_membership_expiration_emailalert_template}	= qq`Hello,\n\nYour membership in the "%%group%%" group at http://$ENV{HTTP_HOST}/ has expired.  If you'd like to re-join this group, please use the following link:\n\n\t%%join_paid_group_link%%\n\nThanks,\n$ENV{HTTP_HOST}\n%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}\n`;



############################################################################
# The confusingly-named groups_that_can_manage_subgroup_users option is for
# the situation where you want some non-admin users to be able to create and
# delete user accounts, but only if those accounts are members of a special
# group.
#
# To explain how this works, we'll refer to the non-admin users with the
# limited create/delete privileges as "subadmins".  So you would create a
# group called "subadmins" and then set this option like this:
#
#	$PREF{groups_that_can_manage_subgroup_users} = 'subadmins';
#
# Note that it doesn't *have* to be called "subadmins" and you can actually
# put multiple groups in there, separated by commas.  You just have to be
# sure to actually create the group via UserBase's Manage Groups page.
#
# Now let's say you have a user named Tom who you'd like to be a subadmin.
# You would of course simply add him to the subadmins group via the UserBase
# Manage Users page.
#
# That allows Tom to create user accounts, but the accounts he creates will
# always automatically get put into a special group named Tom_group.  And
# by the same token, Tom can delete user accounts, but only accounts which
# belong to the Tom_group group.
#
#	Note: do NOT add "subadmins" to the groups_allowed_to_create_new_accounts
#	setting; that would bypass this whole subadmin/subgroup feature and give
#	the group full create/delete account privileges.
#
# Any subadmins (like Tom in the example) cannot create admin accounts, and
# therefore cannot check the "admin" box under "Group Memberships" while
# editing accounts.
#
# You can specify a suffix other than "_group" (as in, Tom_group), but you
# probably shouldn't do that if you already have a bunch of subadmins and
# they already have a bunch of users, because then you'll have to go into
# the Manage Users page and manually update a bunch of users and groups.
#
# The $PREF{subgroup_owned_users_get_group_memberships_from_their_manager}
# causes any users created by Tom to automatically be added to any groups
# that Tom himself belongs to (except for the subadmins group itself).  Note
# that this occurs when the new sub-account is created; if Tom's group
# memberships are later changed, that does not change the group memberships
# of any of his already-existing sub-accounts.
#
$PREF{groups_that_can_manage_subgroup_users}		= '';
$PREF{subgroup_groupname_suffix}			= '_group';
$PREF{subgroup_owned_users_get_group_memberships_from_their_manager} = 'no';
$PREF{include_subadmin_details_in_chklogin_output}	= 'no';



############################################################################
# Some users end up frequently adding inadvertent spaces to the start/end of
# their usernames/passwords while trying to log in, resulting in many 
# repeated failed logins and password-resets even though the user "knows"
# that he entered the right username/password, darn it!  Since those spaces
# are never valid on usernames and probably exceedingly rare on passwords,
# you can avoid this frustration by just always stripping them.
# 
$PREF{strip_leading_and_trailing_spaces_from_usernames_during_login} = 'yes';
$PREF{strip_leading_and_trailing_spaces_from_passwords_during_login} = 'yes';



############################################################################
# Set options for usernames, groupnames, etc.
#
$PREF{allow_spaces_in_usernames}			= 'no';
$PREF{allow_atsigns_in_usernames}			= 'yes';
$PREF{allow_dots_in_usernames}				= 'yes';
$PREF{allow_dashes_in_usernames}			= 'yes';
$PREF{usernames_must_be_email_addresses}		= 'no';
#
$PREF{allow_spaces_in_groupnames}			= 'yes';
$PREF{allow_atsigns_in_groupnames}			= 'yes';
$PREF{allow_dots_in_groupnames}				= 'yes';
$PREF{allow_dashes_in_groupnames}			= 'yes';
#
$PREF{allow_underscores_in_realnames}			= 'no';



############################################################################
# Set min/max lengths for strings.
#
$PREF{max_groupname_length}				= 50;
$PREF{max_realname_length}				= 50;
$PREF{max_emailaddr_length}				= 90;
$PREF{max_group_description_length}			= 2000;



############################################################################
# User info options.
#
$PREF{use_builtin_realname_field}			= 'yes';
$PREF{use_builtin_email_field}				= 'yes';
$PREF{email_field_required_during_signup}		= 'yes';
$PREF{email_field_required_for_loggedin_users}		= 'yes';
$PREF{default_bgcolor_for_required_fields}		= '#ffffff';
$PREF{default_textcolor_for_required_fields}		= '#000';
$PREF{bgcolor_for_unfilled_required_fields}		= '#ffdd00';
$PREF{textcolor_for_unfilled_required_fields}		= '#000';
$PREF{log_all_userinfo_updates}				= 'no';
$PREF{send_email_notification_upon_userinfo_updates}	= 'no';
$PREF{userinfo_updates_notification___sender}		= '%PREF{app_email_address}'; # one address.
$PREF{userinfo_updates_notification___recipient}	= '%PREF{webmaster_email_address}';   # one or more addresses, comma-separated; can include %%self%%.
$PREF{userinfo_updates_notification___subject}		= qq`User info changed on $ENV{HTTP_HOST}`;
$PREF{userinfo_updates_notification___format}		= qq`text`;
$PREF{userinfo_updates_notification___body}		= qq`User info changed:

User %%changer_username%% has updated the account information for user %%changee_username%%:

%%changelist%%

If you believe this change has been made in error, please contact us.

--
Sent by %PREF{title_text} at: %PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}
`;



############################################################################
# Image options.
#
$PREF{enable_profile_images}				= 'yes';
$PREF{profile_image_sizes_to_create}			= '80,500';
$PREF{profile_image_supported_extensions}		= 'jpg|jpeg|png'; # separate extensions with a "|" character.

$PREF{image_resizing_timeout}				= 8; # in seconds.
$PREF{items_per_page_on_item_image_viewer}		= 10;
$PREF{ignore_image_resizing_errors}			= 'yes'; # otherwise, corrupt/fake images result in error messages.

$PREF{try_to_use_convert_for_resizing}			= 'no';
$PREF{try_to_use_convert_for_humantest}			= 'no';
$PREF{convert_command}					= 'convert'; # can optionally include path.
$PREF{convert_resize_template}				= qq`%PREF{convert_command} -filter lanczos -size %%size%% -resize %%size%% -quality 95 "%%infile%%" "%%outfile%%"`;

$PREF{try_to_use_identify_for_dimensions}		= 'no';
$PREF{identify_command}					= 'identify'; # can optionally include path.

$PREF{try_to_use_imagemagick_for_resizing}		= 'yes';
$PREF{try_to_use_imagemagick_for_dimensions}		= 'yes';
$PREF{try_to_use_imagemagick_for_humantest}		= 'yes';

$PREF{try_to_use_gd_for_resizing}			= 'yes';
$PREF{try_to_use_gd_for_dimensions}			= 'yes';
$PREF{try_to_use_gd_for_humantest}			= 'yes';

# Experimental: to try netpbm, delete the "#" from the start of this line:
#$PREF{netpbm_command_for_humantest}			= qq`ppmmake %PREF{human_test_background_color} %PREF{human_test_image_width} %PREF{human_test_image_height} |ppmlabel -color %PREF{human_test_text_color} -size 12 -text %%random_number%% |ppmtojpeg >"%%output_filename%%"`;




############################################################################
# You can choose to prevent a user from being logged in from 2 different
# locations (browsers) at the same time.  If you enable this, you should
# also take steps to prevent a user from locking himself out by accidentally
# staying logged in at another location; this means you must either set
# in_illegal_multilogon_dispute_which_user_gets_kicked to 'old', or else set
# the idle timeout.
#
# The idle timeout automatically expires the user's login session (i.e.
# automatically logs him out) after a certain number of idle seconds.  Set
# the timeout to zero to disable it.
#
# The "Remember Me" checkbox is approximately an inverse of the idle
# timeout: instead of automatically logging the user out after a period of
# inactivity, we automatically remember the user for X number of days, even
# if they close their browser, reboot their computer, etc.
#
$PREF{prevent_multiple_simultaneous_logons_per_username}= 'no';
$PREF{in_illegal_multilogon_dispute_which_user_gets_kicked} = 'old'; # old or new.
$PREF{idle_timeout}					= 60 * 0; # in seconds.
$PREF{enable_rememberme_checkbox}			= 'yes';
$PREF{num_days_rememberme_cookie_lasts}			= '15';



############################################################################
# The human test is meant to prevent spambots and other malware from
# hammering on your sign-up page.  It asks a question that should be easy
# for a person to answer, but difficult for a computer to answer.  Currently
# this means displaying an image containing random characters and asking the
# user to type those characters into an input field.
#
# This type of test is sometimes called a CAPTCHA; this term is trademarked
# by Carnegie Mellon University.
#
# If you want to use this feature, you should start by using the invisible
# mode (human_test_is_invisible).  This method relies on the fact that
# Javascript is not supported by the various nastybots that will abuse your
# site, so we use Javascript to hide the human test and fill in the correct
# answer automatically, thereby not requiring any actual human involvement.
# But, if the nastybots are still getting through, then try enable_human_test
# without the invisible option.
#
# The image directory must be world-writable (0777) and within the DOCROOT
# but not inside the cgi-bin.
#
# The default salt value is probably fine.  If your site is getting
# successfully hammered despite the human test being enabled, changing
# the salt periodically may help.
#
$PREF{enable_human_test}				= 'no';
$PREF{human_test_is_invisible}				= 'yes';
$PREF{human_test_num_digits}				= 6; # from 1 to 15.
$PREF{human_test_salt_value}				= substr($ENV{HTTP_HOST}, 0, 5);
$PREF{human_test_image_width}				= '80';
$PREF{human_test_image_height}				= '24';
$PREF{human_test_font_name}				= 'Helvetica'; # Try Helvetica, Courier, Arial, etc.  Currently ImageMagick-only.
$PREF{human_test_text_size}				= '18'; # Note: has no effect on some GD-only servers.
$PREF{human_test_text_color}				= 'black';
$PREF{human_test_background_color}			= 'white';
$PREF{human_test_border_size}				= '1';
$PREF{human_test_border_color}				= 'gray';
$PREF{human_test_margin}				= '5px';



############################################################################
# Various settings.
#
$PREF{preserve_URL_variables_through_login_process}	= 'no';
$PREF{preserve_URL_variables_through_signup_process}	= 'no';
$PREF{server_handles_ip_addresses_incorrectly}		= 'no';
$PREF{force_nocache_on_all_output}			= 'no';
$PREF{userbase_table_name_alternative_prefix}		= '';   # should be null in most cases.
$PREF{static_hostname}					= '';   # if the app takes a long time to load, try setting this to your site's domain name (e.g. 'yoursite.com').



############################################################################
# Various security options.
#
$PREF{num_seconds_to_sleep_on_failed_login}		= 1;
$PREF{lock_account_after_N_failed_logins}		= 5; # null to disable.
$PREF{failed_logins_within_N_secs_count_towards_lock}	= 600; # null to disable (then all failures count).
$PREF{lock_expires_automatically}			= 'yes';
$PREF{enable_ip_address_restriction}			= 'no';
$PREF{force_ip_address_restriction}			= 'no';
$PREF{disable_ip_restriction_for_AOL_users}		= 'yes';
$PREF{enable_password_reset}				= 'yes';
$PREF{password_reset_delay}				= 10;   # in seconds; don't make this too long.
$PREF{password_reset_timeout}				= 60 * 60;   # in minutes; don't make this too long.
$PREF{pwreset_should_lie_about_nonexistent_accounts}	= 'yes'; # For security purposes, don't print "username not found"; just act like it was found.
$PREF{lie_about_invalid_accts_when_resending_verification_emails} = 'yes'; # For security purposes, don't display errors that could give away which IDs/usernames exist.
$PREF{passwords_must_contain_a_lowercase_letter}	= 'no';
$PREF{passwords_must_contain_an_uppercase_letter}	= 'no';
$PREF{passwords_must_contain_a_number}			= 'no';
$PREF{passwords_must_contain_a_nonalphanumeric_char}	= 'no';



############################################################################
# Case-insensitivity is a bad idea.  It makes your system less secure.
# Don't do it.
#
$PREF{make_usernames_case_insensitive}			= 'no';
$PREF{make_passwords_case_insensitive}			= 'no';



############################################################################
# You can use a blacklist or a whitelist to prevent users from accessing the
# entire app (with the forced_* settings), or just certain features of the
# app (with the grouped_* settings).  A forced_blacklist means "block this
# user" and a forced_whitelist means "block EVERY user except this one", so
# if you're going to use a forced_* setting then it should probably be
# forced_blacklist in most cases.  If you specify both forced_blacklist and
# forced_whitelist settings, then only the whitelist will be used, since
# it's the more restrictive of the two.  The rules for the grouped_* settings
# are slightly different; see the note at the bottom of this section.
#
# These values are regular expressions, which means that some characters
# have special meanings (like dots) so they must be "escaped" using a back-
# slash, and that partial matching will be done unless you use "^" and "$"
# to mark the start and end of the value.  For example, if you want to match
# only the exact IP address 12.34.56.78, you would use the following:
#
#	$PREF{forced_blacklist_ip_addresses}{'01'} = '^12\.34\.56\.78$';
#
# Or if you want to match any IP that starts with 12.34., you'd use this:
#
#	$PREF{forced_blacklist_ip_addresses}{'01'} = '^12\.34\.';
#
# Or to match any IP that contains .34.56., you'd use this:
#
#	$PREF{forced_blacklist_ip_addresses}{'01'} = '\.34\.56\.';
#
# Note that the values here must be in single-quotes, not double-quotes.
#
# You can add as many rules as you want; just increment the number in '01',
# '02', etc.
#
# The forced_blacklist_* and forced_whitelist_* settings here are for the whole
# app: at the start of execution, we'll check these lists and block any user in
# the blacklist, and pass any user in the whitelist.  This does not deal with any
# specific features or functions; it's a whole-app pass-or-fail checkpoint.  In
# contrast, the grouped_blacklist_* and grouped_whitelist_* settings just add any
# matching user to the built-in encblacklisted/encwhitelisted groups, which you
# can then use within any groups_allowed_to_* setting to block or allow access
# to specific features of the app.
#
# For example, if you have the app installed on a local server whose IP address
# is 10.10.10.10, and you want to require that users be members if they're
# coming from the outside world, but waive that requirement if they're coming
# from the local network, then you could set the relevant groups_allowed_to_*
# setting(s) to 'member,encwhitelisted' and then create a grouped_whitelist 
# setting like this:
#
#	$PREF{grouped_whitelist_ip_addresses}{'01'} = '^10\.10\.10\.';
#
# Then access would be limited to members and people in the 10.10.10.* subnet.
#
$PREF{forced_blacklist_ip_addresses}{'01'}		= '';
$PREF{forced_blacklist_ip_addresses}{'02'}		= '';
$PREF{forced_blacklist_hostnames}{'01'}			= '';
$PREF{forced_blacklist_hostnames}{'02'}			= '';
#
$PREF{forced_whitelist_ip_addresses}{'01'}		= '';
$PREF{forced_whitelist_ip_addresses}{'02'}		= '';
$PREF{forced_whitelist_hostnames}{'01'}			= '';
$PREF{forced_whitelist_hostnames}{'02'}			= '';
#
$TEXT{failed_black_or_white_list}			= qq`Access denied based on blacklisted or whitelisted IP address or hostname.`;
#
$PREF{grouped_blacklist_ip_addresses}{'01'}		= '';
$PREF{grouped_blacklist_ip_addresses}{'02'}		= '';
$PREF{grouped_blacklist_hostnames}{'01'}		= '';
$PREF{grouped_blacklist_hostnames}{'02'}		= '';
#
$PREF{grouped_whitelist_ip_addresses}{'01'}		= '';
$PREF{grouped_whitelist_ip_addresses}{'02'}		= '';
$PREF{grouped_whitelist_hostnames}{'01'}		= '';
$PREF{grouped_whitelist_hostnames}{'02'}		= '';



############################################################################
# Using binary salt can increase security, but not all servers will support
# it.  If you enable this, you'll need to manually change the type of your
# salt column from VARCHAR to VARBINARY, using phpMyAdmin or some other
# interface to MySQL.  For example in the MySQL command-line client you
# would use this command:
#
#	ALTER TABLE `userbase_users` MODIFY `salt` VARBINARY(50) NOT NULL;
#
$PREF{use_binary_salt}					= 'no';



############################################################################
# Configure the force-password-change feature.
#
$PREF{enable_forced_password_change}			= 'yes';
$PREF{admins_can_be_forced_to_change_their_own_pws}	= 'yes';
$PREF{force_pw_chng_after_first_login}			= 'no';
$PREF{force_pw_chng_after_password_reset}		= 'yes';
$PREF{force_pw_chng_after_this_many_hours}		= 24*0; # zero to disable.



############################################################################
# FileChucker options.  Note that FileChucker will automatically create each
# user's userdir when that user first logs in.  You only need to enable the 
# create_filechucker_userdir_on_account_creation setting if you need to have
# each userdir be created when the user's account is created, instead of
# when the user first logs in.
#
$PREF{create_filechucker_userdir_on_account_creation}	= 'no';
$PREF{filechucker_userdir_folder}			= '/upload/files/users';
$PREF{filechucker_userdir_folder_is_in_docroot}		= 'yes';
$PREF{filechucker_userdir_template}			= '%%username%%'; # must match $PREF{userdir_template} from FC prefs.



############################################################################
# Extra header output: this lets you specify HTML code to appear within the
# <head> section of UserBase's output.  For example, to make your site's
# favicon appear:
#
#	$PREF{extra_header_output} = qq`<link rel="icon" href="/favicon.ico" type="image/png" />`;
#
# Or if you're using VisitorLog, and you want it to log your UserBase
# page views:
#
#	$PREF{extra_header_output} = qq`<script type="text/javascript" src="/visitors/js/vlog.js"></script>`;
#
# You can include as many lines as you want in this setting, and it can be
# any valid HTML or anything else that's valid within the <head>...</head>
# section of a webpage.
#
# Other header-type options: you should use Font Awesome, but if for some
# reason you don't want to, then set that pref to ''.
# 
$PREF{extra_header_output}				= '';
$PREF{fontawesome_tag}					= qq`<link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css">\n`;



############################################################################
# Here you can specify your own custom Javascript code.  Leave off the
# <script> tags.  And you can use schedule_onload_action(myfunction); to
# hook into the onload logic.
#
$PREF{custom_js_code}					= qq``;



############################################################################
# UserBase will automatically create and update static CSS and JS files,
# in the /login/appdata/ub.css and ub.js files by default.  As you change
# various prefs, the contents of these files will need to be updated, so it's
# best to let UserBase manage these files.  (And you can adjust $PREF{css}
# and $PREF{custom_js_code} to customize your CSS/JS; those changes will be
# automatically incorporated into the static files.)  But if for some reason
# you want to manage these files manually, you can disable the create/update
# prefs.  And you can set the URLs to null to make UserBase use inline CSS
# and JS.
# 
$PREF{static_css_url}					= "%PREF{appdir_url}/ub.css";
$PREF{static_js_url}					= "%PREF{appdir_url}/ub.js";
$PREF{create_static_css_and_js_files_automatically}	= 'yes';
$PREF{update_static_css_and_js_files_when_prefs_file_changes} = 'yes';
$PREF{update_static_css_and_js_files_at_regular_interval} = 60*60*12;   # in seconds; zero to disable.



############################################################################
# On most servers, you can embed UserBase into an existing page/layout
# using PHP or SHTML and the ?encembed=yes variable, as explained in the
# FAQ.  However, if you're on a brain-dead server (for example, IIS6+) which
# does not support any decent way to call a CGI script that includes the
# proper server environment variables, and your server does not have PHP
# installed, and you still want to include a standard header/footer with
# UserBase, then you can set encodable_app_template_file.  Set this to
# the full path (probably starting with "%PREF{DOCROOT}/") to an HTML page
# on your site which should be used as the template for UserBase's
# output.  You can create this HTML file in whatever way you normally
# create web pages; the only requirement is that it contain the string
# %%encodable_app_output%% wherever you'd like UserBase's output to appear,
# No server-side processing (PHP, SSI, etc) will be done on the contents of
# this file; however you can specify a title for UserBase to insert on the
# existing <title>...</title> line within the file.
#
# You can also do custom replacements in your template.  For example, if
# you put this in your template file:
#
#	<!--EncReplace001Start--><img src="/images/header/default.jpg" /><!--EncReplace001End-->
#
# ...and set your prefs like this:
#
#	$PREF{encodable_app_template_replacement_001}		= qq`<img src="/images/header/%COOKIE{user}.jpg" />`;
#	$PREF{encodable_app_template_replacement_001_test}	= '%COOKIE{user}';   # if the value is null, the test fails, so no replacement is done.
#
# ...then you'd get custom per-user header images, if the "user" cookie is set.
#
$PREF{encodable_app_template_file}			= '';
$PREF{encodable_app_template_css_insertion_point}	= 'bottom';   # 'top', 'bottom', or '' (refers to location within <head>).
$PREF{encodable_app_template_js_insertion_point}	= 'bottom';   # 'top', 'bottom', or '' (refers to location within <head>).
$PREF{title_for_template_file}				= '';
$PREF{encodable_app_template_replacement_001}		= qq``;
$PREF{encodable_app_template_replacement_001_test}	= '';



############################################################################
# Web servers treat "www.you.com" and "you.com" as two different domains,
# which matters for web applications that use cookies.  So you should make
# your website either always use the www, or always remove it.  You should
# be able to do this in your server configuration, but if not, you can do
# it here.  Whether to use www or not is only a matter of taste, so just 
# pick whichever way you want, and then stick with it.
#
$PREF{add_www_to_hostname}				= 'no';
$PREF{remove_www_from_hostname}				= 'no';



############################################################################
# Directory permissions: these should usually be 0777; on some servers, you
# may be able to get away with using less-permissive settings like 0755 or
# even 0700 instead.
#
# File permissions: these should usually be 0666; on some servers, you
# may be able to get away with using less-permissive settings like 0644 or
# even 0600 instead.
#
$PREF{writable_dir_perms}				= 0777;		# no quotes. default is 0777.
#
$PREF{writable_file_perms}				= 0666;		# no quotes. default is 0666.



############################################################################
# Various templates and markup.
#
# The PREF for loggedout_page_template__with_referer is used when a user
# clicks a "logout" link on some other page; we then display this message
# with a link to return to that other page (the referer).  Otherwise we
# just display the __no_referer message.
#
$PREF{username_label}					= 'Username';
$PREF{name_label}					= 'Full Name';
$PREF{email_label}					= 'Email Address';
$PREF{date_format_for_users_page}			= '%Y%m%d-%H%M';
$PREF{mainmenu_page_template}				= qq`%%menus%%`;
$PREF{mainmenu_template}				= qq`<div class="encmenu">\n<div class="header"><i class="ub-header-icon fa-wait fa-user-or-something"></i> %%title%%</div>\n<div>%%links%%</div></div>\n`;
$PREF{show_link_to_member_directory_on_member_mainmenu}	= 'yes';

$PREF{forced_logout_link}				= qq`<script type="text/javascript">location.href="%%logout_url%%";</script><p>Logging out; <a href="%%logout_url%%">click here</a> if you see this message for more than a few seconds.</p>\n`;
$PREF{loggedout_page_template__no_referer}		= qq`You are logged out.`;
$PREF{loggedout_page_template__with_referer}		= qq`You are logged out.&nbsp; <a href="%%ref%%">Click here</a> to return to the page you came from.`;
$PREF{login_status_string_template}			= qq`[ %%usertype%% %%username%% logged in%%extra_info%%. ]`;
$PREF{needlogin_message}				= qq`<h1 class="pagetitle">Login Required</h1><p>Login required; <a href="%%login_url%%">click here</a> to continue.</p>`;
$PREF{needprivs_message}				= qq`<h1 class="pagetitle">Access Denied</h1><p>Access denied.&nbsp; %%%if-notloggedin%%%Perhaps you need to <a href="%%login_url%%">login</a> first?%%%end-notloggedin%%%</p>`;



############################################################################
# App output template.  You can add things here, and you can change any text
# within the template, but you probably shouldn't change any of the markup
# (tags) nor variables (like %%linkbar_bottom%%) within the template.
#
$PREF{app_output_template} = qq`

	<div id="ubwrapper" class="%%wide_page_css_wrapper_id%%">

	<div id="%%on_page%%page"> <!-- this is #cartpage, #storepage, #defaultpage, etc. -->

	%TEXT{custom_header_output}

	%%%if-pagetitle%%%	<h1 class="pagetitle">%PREF{title}</h1>		%%%end-pagetitle%%%
	%%%if-pagesubtitle%%%	<div class="pagesubtitle">%%subtitle%%</div>	%%%end-pagesubtitle%%%

	<div id="ub_content"> <!-- don't change this ID. -->


	%%app_output_body%%


	</div>

	<div id="ublinkbar_bottom">
	%%linkbar_bottom%%
	</div>

	<div id="epb">%%powered_by%%</div>

	</div> <!-- end #cartpage, #storepage, #defaultpage, etc. -->

	</div><!-- end id="ubwrapper" -->
`;



############################################################################
# These prefs allow you to create a fully customized main menu page.  Just
# specify the filename (including full path, or path relative to your
# DOCROOT) to the HTML file containing your main menu.  You should not
# include the HTML tags <html>, <head>, nor <body>, nor their close-tags,
# within your file, unless you enable the hide_ prefs here.
#
# Within your page, you must use the following code to tell UserBase which
# groups should see which parts of your page:
#
#	<!-- %%%group-member%%% -->
#	(your members-only code here)
#	<!-- %%%end-group-member%%% -->
#
#	...
#
#	<!-- %%%group-admin%%% -->
#	(your admin-only code here)
#	<!-- %%%end-group-admin%%% -->
#
$PREF{custom_mainmenu_page}				= '';
$PREF{hide_builtin_header_on_custom_mainmenu}		= 'no';
$PREF{hide_builtin_footer_on_custom_mainmenu}		= 'no';



############################################################################
# Specify footer options here.  If you set $PREF{custom_footer_links} to
# anything other than null, it will disable all the built-in footer links.
# Alternatively, if you just want to add additional links to the current
# footer, then use $PREF{extra_footer_links}, like this:
#
#	$PREF{extra_footer_links} = [ '<a href="/foo">Foo</a>',  '<a href="/bar">Bar</a>' ];
#
$PREF{home_link_name}					= 'Home'; # null to disable.
$PREF{home_link_url}					= '/';
$PREF{signup_link_name}					= 'Create Account';
$PREF{signup_link_url}					= '%PREF{login_url}?action=signup';
$PREF{show_logout_link_in_footer}			= 'yes';
$PREF{show_myaccount_link_in_footer}			= 'yes';
$PREF{login_footer_link_name}				= 'Login';
$PREF{myaccount_footer_link_name}			= 'My Account';
$PREF{show_login_status_in_footer}			= 'yes';
$PREF{custom_footer_links}				= '';
$PREF{extra_footer_links}				= [];



############################################################################
# The Manage Users page contains a table that may be too wide for some
# narrow layouts.  To work around that, you can specify that certain columns
# should be hidden by default.  They can always be manually displayed by
# simply clicking on the appropriate link on the Manage Users page.  The
# column names are ubusername, ubgroups, ubrealname, ubemail, ubcreatedate,
# ubloggedin, ubactions, and also the names of any custom fields that you've
# created.  You can specify one or more here, separated by commas.
#
$PREF{columns_hidden_by_default_on_user_manager}	= 'ubcreatedate,ubloggedin,ublastlogin,ublastactive,ubfirst_visit_today,ubpassword,ubpwformat,ubpendpaymt,ubtxnids,ubdaysexp,ubsincelogin,ubdaysinactive';
$PREF{default_sort_column_for_user_manager}		= 'ubusername';



############################################################################
# The $PREF{debuglog} setting outputs to a file in the app's encdata/
# directory.  It's meant mainly for servers without proper STDERR support,
# and for internal debugging rather than end-user usage.
#
$PREF{debuglog}						= 'no';
$PREF{debuglog_to_stderr}				= 'no';



############################################################################
# UserBase does automatic login redirection as explained in this FAQ item:
#
#	http://encodable.com/userbase/faq/#redirection
#
# However, you can override this behavior here.  Specify the URL to go to
# for each situation.  Each URL should be a relative link, starting with a 
# single forward-slash; or, it can start with a fully-qualified domain name,
# preceeded by http:// or https://.  For example, to redirect your members
# to www.yoursite.com/private.shtml upon login, you should set the following:
#
#	$PREF{on_member_login_redirect_to} = '/private.shtml';
#
# You can also specify that when a user visits the script, even if he's not
# in the process of logging in or logging out, we'll still redirect him to
# a different URL.  To enable this, set the "always_redirect" PREFs.
#
# The $PREF{on_fake_logout_redirect_to} is for the case when a user visits
# our logout URL, but he's not actually logged in.  That shouldn't happen
# in most installations, but it can if, for example, you've hard-coded one
# of your links to point to the logout URL, and the link is in a page that
# the user can access even when not logged in.
#
# Note that you can include %%username%% as a variable in these URLs, to
# insert the visitor's username, sending each user to a unique URL.  And
# you can create new prefs here of the form on_groupname_login_redirect_to,
# where "groupname" is the name of any group that you've created.  You can
# also specify the special keyword "paidmemberacct" as a groupname (but don't
# actually create a group with that name) to redirect any user who belongs to
# any paid group in your system.  You can include the variable %%idtoken%% if
# you're using this UserBase installation to "protect" content that's on a
# different website (which is a weak and not-very-secure way to protect
# content so it is not recommended).
#
# You can also set any of these to "referer", in which case we'll redirect
# the user to the referring page -- the page he came from.  In this case
# you must also set a backup address in case the user visits us directly,
# i.e. no referer is set.
#
$PREF{on_member_login_redirect_to}			= '';
$PREF{on_member_logout_redirect_to}			= '';

$PREF{on_admin_login_redirect_to}			= '';
$PREF{on_admin_logout_redirect_to}			= '';

$PREF{on_fake_logout_redirect_to}			= '';

$PREF{on_failed_login_redirect_to}			= '';

$PREF{always_redirect_members_to}			= '';
$PREF{always_redirect_admins_to}			= '';

$PREF{redirection_backup_address}			= '/';
$PREF{redirect_to_referer_on_logout}			= 'no';



############################################################################
# Or, if you want to allow redirection to different pages based on variables
# that you can pass on the URL, use these settings.  For example, if you
# specify this:
#
#	$PREF{loginreturn}{foo} = '/bar.html';
#
# ...then when a logged-out user visits www.example.com/login/?loginreturn=foo
# and then successfully logs in, he'll be redirected to /bar.html.
#
# These are commented-out by default, so to enable them you must uncomment
# them (delete the "#" at the front of the line) first.
#
#$PREF{loginreturn}{foo}				= '/bar.html';
#$PREF{loginreturn}{bim}				= '/baz/';



############################################################################
# You can adjust the order in which the login destination options apply.
# loginreturn is the $PREF{loginreturn} settings; redirect is the various
# on_*_login_redirect_to settings; and referer is the ?whence=/somepage
# URL variable that's created when a logged-out user tries to visit a page
# that's protected by UserBase.
#
# In any situation where more than one of those options are present, the
# first one in this list will take precedence.  So for example, if you want
# your on_*_login_redirect_to settings to only take effect when no referer
# is present, then you'd swap their order within this setting.
#
# This should be left at its default value in most cases.
#
$PREF{login_destination_precedence_list} = 'loginreturn, redirect, referer';



############################################################################
# We'll automatically delete old temp files, such as human test images.  Set
# the max_age_for_* setting(s) to the age (in hours) at which you'd like old
# files to get deleted.  This age can be a fractional (decimal) number.
#
# In order for this to work, the script must actually be running at the
# hour(s) that you specify in hours_at_which_to_check_for_old_files, i.e. a
# visitor must access some part of the app during those hours.  So if your
# installation doesn't get very many visitors, and your old files aren't
# getting deleted, try adding a few more hours to the list.
# 
$PREF{automatically_delete_old_humantest_images}	= 'yes';
$PREF{max_age_for_humantest_images}			= '1'; # In hours.
$PREF{hours_at_which_to_check_for_old_files}		= '0,6,12,18'; # can be from 0 to 23.



############################################################################
# Event calender settings.
#
$PREF{enable_event_calendar}				= 'no';
$PREF{event_calendar_reminder_email_sender}		= '%PREF{app_email_address}';
$PREF{event_calendar_reminder_email_subject}		= qq`Event reminder: %%eventname%%`;
$PREF{event_calendar_reminder_email_format}		= qq`html`; # text or html.
$PREF{event_calendar_reminder_email_template}		= qq`
<p>Hello,</p>

<p>This is your reminder for the following upcoming event:</p>

<p>Name: %%eventname%%
<br />Date: %%eventdate%%
<br />Details: %%eventdescription%%</p>

<p><br /></p><hr />
<p>This message sent by %PREF{title_text} at:</p>
<p><a href="%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}">%PREF{protoprefix}$ENV{HTTP_HOST}%PREF{login_url}</a></p>
`;




############################################################################
# Settings for various logs/viewers/tables.
#
$PREF{logins_viewer_title}				= 'Logins';
$PREF{logins_viewer_hidden_columns}			= 'id,session_id,ip_address,user_id,timestamp';
$PREF{logins_viewer_max_display_length}			= 50;
$PREF{logins_viewer_itemsperpage}			= 25;
$PREF{num_logins_to_log_per_user}			= 10;
#
$PREF{failed_logins_viewer_title}			= 'Failed Logins';
$PREF{failed_logins_viewer_hidden_columns}		= 'id,password_fingerprint,ip_address,timestamp';
$PREF{failed_logins_viewer_max_display_length}		= 50;
$PREF{failed_logins_viewer_itemsperpage}		= 25;
$PREF{num_failed_logins_to_log_per_user}		= 100;
#
$PREF{password_activity_viewer_title}			= 'Password Updates';
$PREF{password_activity_viewer_hidden_columns}		= 'id,user_id,ip_address,timestamp,user_who_did_update,salt';
$PREF{password_activity_viewer_max_display_length}	= 50;
$PREF{password_activity_viewer_itemsperpage}		= 25;
$PREF{num_pw_updates_to_log_per_user}			= 10;
#
$PREF{userinfo_updates_viewer_title}			= 'User Info Updates';
$PREF{userinfo_updates_viewer_hidden_columns}		= 'id,changer_id,changee_id,ip_address,timestamp';
#
$PREF{enable_quicksort_by_default}			= 'yes';




############################################################################
# Customizable messages.
#
$PREF{invalid_username_message}				= qq`Username invalid: must contain only letters, numbers, and underscores; and must be less than $PREF{max_username_length} characters.`;
$PREF{invalid_realname_message}				= qq`Fullname invalid: must contain only letters, numbers, spaces, dots, dashes, and quotes; must start with a letter; and must be less than $PREF{max_realname_length} characters.`;
$PREF{invalid_password_message}				= qq`Password invalid: must be between $PREF{min_password_length} and $PREF{max_password_length} characters.`;
$PREF{invalid_groupname_message}			= qq`Groupname invalid: must contain only letters, numbers, and underscores; must start with a letter; and must be less than $PREF{max_groupname_length} characters.`;
$PREF{invalid_groupdesc_message}			= qq`Group description invalid: must be less than $PREF{max_group_description_length} characters.`;



############################################################################
# Internationalization and Localization (i18n and l10n).
#
# UserBase text strings:
#
$TEXT{messages}{ebadauth}				= qq`Invalid login; please go back and try again.`;
$TEXT{messages}{eacctlck}				= qq`Error: account locked.\n`;
$TEXT{messages}{eacctdis}				= qq`Error: account disabled.\n`;
$TEXT{messages}{eacctlimit}				= qq`Error: you've reached your daily access limit; please come back again tomorrow.\n`;
$TEXT{messages}{eacctpndpmt}				= qq`Error: account still pending due to: payment required.\n`;
$TEXT{messages}{eacctpndvrf}				= qq`Error: account still pending due to: email verification required.&nbsp; You must click the link in the verification email that we sent to you.&nbsp; If you don't see this email in your inbox, you may need to check your spam/junk folder.&nbsp; You can also <a href="%PREF{login_url_qsready}action=resendvrfemail&amp;uid=%%qs_var_uid%%&amp;user=%%qs_var_user%%">click here</a> to send the email again.\n`;
$TEXT{messages}{eacctpndadm}				= qq`Error: account still pending due to: administrator approval required.\n`;
$TEXT{messages}{edenied}				= qq`Access denied.`;
$TEXT{messages}{edupuser}				= qq`Sorry, a user by that name already exists.&nbsp; Please go back and try again.`;
$TEXT{messages}{edupemail}				= qq`Sorry, that email address already exists in the system.&nbsp; Please try again.`;
$TEXT{messages}{emultkicked}				= qq`That username was being used by multiple people/browsers.&nbsp; They have all been forcibly logged out now.&nbsp; You can now try to <a href="%PREF{login_url}">login again</a>, but if your username is still being shared, you'll likely all get kicked out again eventually.&nbsp; The only way to prevent others from using a previously-shared account is for the account owner to <a href="%PREF{login_url}?action=pwreset1">reset the password</a>.`;
$TEXT{messages}{emultlogin}				= qq`You cannot log in, because another person/browser is already logged in with the same username.`;
$TEXT{messages}{einsuff}				= qq`You don't have permission to do that.`;
$TEXT{messages}{elfirst}				= qq`Please login first.`;
$TEXT{messages}{eneedlogin}				= qq`You must log in to use this facility.`;
$TEXT{messages}{eneedadmin}				= qq`You must log in as an administrator to use this facility.`;
$TEXT{messages}{epwmismatch}				= qq`Passwords do not match.&nbsp; Go back and try again.`;
$TEXT{messages}{ebadname}				= qq`$PREF{invalid_username_message}`;
$TEXT{messages}{ebadopwuid}				= qq`Old password incorrect or username/ID mismatch. Please go back and try again.`;
$TEXT{messages}{enpwmis}				= qq`New passwords do not match. Please go back and try again.`;
$TEXT{messages}{enpwl}					= qq`New password too short. Please go back and try again.`;
$TEXT{messages}{einvldr}				= qq`$PREF{invalid_realname_message}`;
$TEXT{messages}{einvlde}				= qq`Email address invalid.&nbsp; Must match the normal user\@domain.com pattern and must not contain spaces`;
$TEXT{messages}{einvldp}				= qq`$PREF{invalid_password_message}`;
$TEXT{messages}{einvldh}				= qq`Hashed password invalid; please contact the webmaster.`;
$TEXT{messages}{einvldgn}				= qq`$PREF{invalid_groupname_message}`;
$TEXT{messages}{einvldgd}				= qq`$PREF{invalid_groupdesc_message}`;
$TEXT{messages}{eipmismatch}				= qq`Your IP address does not match this login session.&nbsp; <a href="%PREF{logoutcookie_url}">Click here to log out</a>.`;
$TEXT{messages}{egrprsvd}				= qq`That groupname is reserved; please go back and change it.`;
$TEXT{messages}{egrpexist}				= qq`That groupname already exists; please go back and change it.`;
$TEXT{messages}{epwrst2}				= qq`Error: email address invalid or nonexistent.&nbsp; Please contact us to have your password reset.`;
$TEXT{messages}{epwrst3}				= qq`Error: that account does not exist in our system.`;
$TEXT{messages}{enosignup}				= qq`New account sign-ups are disabled.`;
$TEXT{messages}{sactapp}				= qq`New account '%%username%%' pending administrator approval.`;
$TEXT{messages}{sactvrf}				= qq`New account '%%username%%' pending email verification; please check your email.`;
$TEXT{messages}{snewadd}				= qq`New account '%%username%%' created successfully.`;
$TEXT{messages}{snewsup}				= qq`New account '%%username%%' created successfully.&nbsp; You can <a href="%PREF{login_url}%%orig_qs%%">log in</a> now.`;
$TEXT{messages}{spwrst2}				= qq`Your password-reset email has been sent.&nbsp; Your password has NOT been reset yet; you must follow the instructions in the email to reset your password.`;

$TEXT{accountlist_filter_label}					= qq`Filter: `;
$TEXT{accountlist_filter_example}				= qq` (for example: groups=admin)`;
$TEXT{Add_all_users_to_group}					= qq`Add all users to this group`;
$TEXT{Add_Custom_Field}						= qq`Add Custom Field`;
$TEXT{Add_New_Field}						= qq`Add New Field`;
$TEXT{Add_User}							= qq`Add User`;
$TEXT{Add_User___subadmin}					= qq`Add User`;
$TEXT{Are_you_sure_you_want_to_delete_user}			= qq`Are you sure you want to delete user`;

$TEXT{Cant_sign_up_already_have_account_}			= qq`You can't sign up for an account because you already have one.`;
$TEXT{choose_atleast_one_group_on_signup_form}			= qq`Please choose one or more groups.`;
$TEXT{choose_atleast_one_paidgroup_on_signup_form}		= qq`Please choose one or more paid groups.`;
$TEXT{choose_exactly_one_group_on_signup_form}			= qq`Please choose one group.`;
$TEXT{choose_exactly_one_paidgroup_on_signup_form}		= qq`Please choose one paid group.`;
$TEXT{Create_Account}						= qq`Create Account`;
$TEXT{Custom_Fields}						= qq`Custom Fields`;
$TEXT{custom_field_DNE_msg}					= qq`ERROR: <span title="this field does not exist in the user table; Edit to fix" class="def">DNE</span>`;
$TEXT{custom_field_OK_msg}					= qq`OK`;

$TEXT{delete_users_confirmation}				= qq`Please confirm: delete %%num%% users now?`;
$TEXT{dirlock_page_title}					= qq`<span class="pagedirlock-title-icon dirlock-title-icon"><i class="fa fa-folder-open"></i><i class="fa fa-lock"></i></span>DirLock: Manage Protected Directories`;
$TEXT{dirlock_popup_instructions}				= qq`This folder and all the pages, files and subfolders in it will be protected, so that only these groups can access it:`;
$TEXT{dirlock_excluded_extension_instructions}			= qq`File types to <em>not</em> protect in this folder: on some servers, protected pages will load faster if you exclude images, CSS files, etc. Separate extensions here with a vertical bar, like this: jpg|css|png<br />Or clear this field to protect all file types:`;

$TEXT{Edit_Custom_Field}					= qq`Edit Custom Field`;
$TEXT{Edit_mainmenu}						= qq`Edit Mainmenu`;
$TEXT{Edit_My_Account_Information}				= qq`View or Edit My Account Information`;
$TEXT{Edit_This_Menu}						= qq`Edit This Menu`;
$TEXT{empty_password_error}					= qq`You must enter your password.`;
$TEXT{empty_username_error}					= qq`You must enter your username.`;
$TEXT{enc_apps_note}						= qq`<div class="enc_box_a" id="enc_apps_note">Like UserBase?&nbsp; Check out <a href="http://encodable.com/filechucker/">FileChucker</a>, <a href="http://encodable.com/cornerstore/">CornerStore</a>,<br />and <a href="http://encodable.com/products/">the rest of Encodable's web apps</a>.</div>\n`;
$TEXT{Enter_the_numbers_in_the_box_below}			= qq`Enter the numbers in the box below.`;
$TEXT{error_account_not_approved}				= qq`Error: account not approved.`;
$TEXT{Error}							= qq`Error`;
$TEXT{Error_input_not_alnum}					= qq`Error: field "%%encfieldname%%" must contain only letters and numbers.`;
$TEXT{Error_input_not_numeric}					= qq`Error: value for field "%%encfieldname%%" must be numeric.`;
$TEXT{Error_input_not_word}					= qq`Error: field "%%encfieldname%%" must contain only letters, numbers, and underscores.`;
$TEXT{Error_input_null}						= qq`Error: field "%%encfieldname%%" cannot be blank.`;
$TEXT{Error_input_too_large}					= qq`Error: value for field "%%encfieldname%%" cannot exceed %%max%%.`;
$TEXT{Error_input_too_long}					= qq`Error: length of input for field "%%encfieldname%%" cannot exceed %%max%% character(s).`;
$TEXT{Error_input_too_short}					= qq`Error: length of input for field "%%encfieldname%%" cannot be less than %%min%% character(s).`;
$TEXT{Error_input_too_small}					= qq`Error: value for field "%%encfieldname%%" cannot be less than %%min%%.`;
$TEXT{Error_not_subadmin}					= qq`Error: you are not a subadmin.`;


$TEXT{Entry_not_bool}						= qq`The value for %%item%% must be either null or 0 or 1; "%%value%%" is invalid.`;
$TEXT{Entry_not_float}						= qq`The value for %%item%% must be a decimal/fractional number; "%%value%%" is invalid.`;
$TEXT{Entry_not_int}						= qq`The value for %%item%% must be a whole number; "%%value%%" is invalid.`;
$TEXT{Entry_not_ufloat}						= qq`The value for %%item%% must be a non-negative decimal/fractional number; "%%value%%" is invalid.`;
$TEXT{Entry_not_uint}						= qq`The value for %%item%% must be a non-negative whole number; "%%value%%" is invalid.`;
$TEXT{Entry_invalid}						= qq`Invalid entry for %%item%% ("%%value%%").`;

$TEXT{e_fldname}						= qq`Error: Field name must contain only letters, numbers, and underscores, and must be 100 characters or less.`;
$TEXT{e_sqlsafe}						= qq`Error: Field contains non-SQL-safe characters: %%fieldname%%\n<br />SQL-safe characters: %PREF{list_of_sql_safe_characters}`;
$TEXT{smsg_e_bltfld}						= qq`Error: That field name is reserved.`;
$TEXT{smsg_e_fldexist}						= qq`Error: That field name already exists.`;
$TEXT{e_fldlabel}						= qq`Error: Field label must be between 1 and 255 characters.`;
$TEXT{e_datatype}						= qq`Error: Data type must contain only letters, numbers, and underscores, and must be 100 characters or less.`;
$TEXT{e_fieldtype}						= qq`Error: Field type must contain only letters, numbers, and underscores, and must be 100 characters or less.`;
$TEXT{smsg_e_fieldpos}						= qq`Error: Field position must contain only numbers (or can be left blank initially)`;
$TEXT{e_alchrmsg}						= qq`Error: Allowed characters message must be less than 255 characters.`;
$TEXT{smsg_e_listitems}						= qq`Error: For dropdown and radio fields, you must enter a list of items/options for the field.`;
$TEXT{smsg_e_missingcode}					= qq`Error: For paid groups, the Code field cannot be empty.`;
$TEXT{e_mandatory}						= qq`The %%item%% field is mandatory.`;
$TEXT{e_toolong}						= qq`Your entry for "%%item%%" was %%length%% characters long, but the limit is %%limit%% characters.`;

$TEXT{Field_contains_non_SQL_safe_characters}			= qq`Field contains non-SQL-safe characters`;
$TEXT{first_admin_created}					= qq`<h3>Setup Complete</h3><p>Your admin account has been created, and your UserBase setup is now complete.&nbsp; <a href="%PREF{login_url}">Click here to log in</a>.</p>`;

$TEXT{ip_address_limit_exceeded_for_group}			= qq`Error: your IP address has already joined this group the maximum number of times.`;
$TEXT{item}							= qq`item`;
$TEXT{items}							= qq`items`;

$TEXT{Locked}							= qq`<i class="fa fa-lock"></i> `;   # Or just "Locked".
$TEXT{Log_Out}							= qq`Log Out`;
$TEXT{Log_Out_All_Locations}					= qq`Log Out All Locations`;

$TEXT{Main_Menu}						= qq`Account Center`;
$TEXT{Manage_Users}						= qq`Manage Users`;
$TEXT{Manage_Users___subadmin}					= qq`Manage Users`;
$TEXT{manage_users_intro_note}					= qq`<p class="intro">You can also <a href="%PREF{login_url_qsready}action=bulkuser" style="text-decoration:underline;">logout or force-reset</a> all accounts.<br />For paid accounts, see the <a href="%PREF{login_url_qsready}action=groups" style="text-decoration:underline;">Manage Groups page</a>.</p>\n`;
$TEXT{manage_users_intro_note___subadmin}			= qq``;
$TEXT{Modify_User}						= qq`Modify User`;
$TEXT{Must_pass_group_id_}					= qq`Must pass group ID on URL.`;

$TEXT{New_Password_}						= qq`New Password:`;
$TEXT{New_Password_again_}					= qq`New Password, again:`;
$TEXT{no_profile_image_msg}					= qq`(No profile image on file.)`;
$TEXT{no_users_selected}					= qq`No users selected.`;

$TEXT{page}							= qq`page`;
$TEXT{pagelock_page_title}					= qq`<span class="pagedirlock-title-icon pagelock-title-icon"><i class="fa fa-file"></i><i class="fa fa-lock"></i></span>PageLock: Manage Protected Pages`;
$TEXT{pagelock_popup_instructions}				= qq`Groups allowed to access this page:`;
$TEXT{pages}							= qq`pages`;
$TEXT{Password_}						= qq`Password:`;
$TEXT{Password_again_}						= qq`Password, again:`;
$TEXT{password_reuse_error}					= qq`Error: you've used that same password recently; for security purposes, you must choose a different password.`;
$TEXT{Password_too_long__the_maximum_}				= qq`Password too long; the maximum length is`;
$TEXT{Password_too_short__the_minimum_}				= qq`Password too short; for security purposes, the minimum length is`;
$TEXT{password_updater_special_cases}				= qq`(initial account creation or password reset)`;
$TEXT{Passwords_do_not_match_}					= qq`Passwords do not match.`;
$TEXT{payment_summary_title}					= qq`Payment Report`;
$TEXT{Please_login_first_}					= qq`Please login first.`;

$TEXT{Remove_all_users_from_group}				= qq`Remove all users from this group`;
$TEXT{Reset_Password}						= qq`Reset Password`;

$TEXT{Save_Changes}						= qq`Save Changes`;
$TEXT{Sign_Up}							= qq`Sign Up`;
$TEXT{SQL_safe_characters}					= qq`SQL-safe characters`;

$TEXT{This_feature_is_disabled_}				= qq`This feature is disabled.`;
$TEXT{title_for_login_form}					= qq`%PREF{title}:`;
$TEXT{title_for_user_form}					= qq`%PREF{title}:`;

$TEXT{Unlocked}							= qq`<i class="fa fa-unlock-alt"></i> `;   # Or just "Unlocked".
$TEXT{userinfo_updates_special_cases}				= qq`(initial account creation or other non-logged action)`;

$TEXT{verification_email_mismatch_error}			= qq`Username does not match user ID.`;
$TEXT{verification_email_notpending_error}			= qq`This account is not pending email verification.`;
$TEXT{verification_email_resent}				= qq`Your verification email has been re-sent.`;
$TEXT{verification_email_resent___full}				= qq`Your verification email has been re-sent, to the following email address: <strong>%%address_obscured%%</strong> (address obscured for security purposes).`;
$TEXT{verification_email_token_error}				= qq`Missing/invalid email verification token.`;
$TEXT{View_Member_Directory}					= qq`View Member Directory`;









############################################################################
# Here you can add/edit CSS (styling) for UserBase.  The $PREF{css} setting
# applies to both the light and dark styles; then the $PREF{css_light} and
# $PREF{css_dark} let you adjust each one individually.
#
$PREF{default_app_style} = 'light';   # light or dark.
$PREF{css} = qq`
#ubbody, #ubbody table { font: 10pt sans-serif; color: #575757; text-align: center; }
.encnarrow #ubwrapper { width: 500px; margin: 0 auto; }
.encmidwidth #ubwrapper { width: 650px; margin: 0 auto; }


/* Fix any stupid overly-broad CSS from site-wide stylesheets: */
#ubbody table td { font: 10pt sans-serif; color: #575757; }
#ubbody p { margin: 10px auto; width: auto; }

#ubbody .pagesubtitle { font-size: 12pt; font-weight: bold; }
#ubbody a { color: #507090; }
#ubbody a:hover { color: #a0a0a0; text-decoration: underline; }
#ublinkbar_bottom { width: 100%; text-align: center; }
#ublinkbar_bottom a, #epb a, #showusers a, .listug-letters a, #columntoggles a, #ubbody #db_viewer_table a { text-decoration: none; }
.ublinkbar_links { margin-top: 15px; padding-top: 15px; }
.ublinkbar_status { text-align: center; margin: 15px auto 0px auto; }
#epb { margin-top: 15px; font-size: 90%; }
.userinfoleft { width: 48%; float: left; text-align: left; }
.userinforight { width: 48%; float: right; text-align: right; }
.label { font-weight: bold !important; }
.label p { max-width: 200px; }
#ubbody input.default		{ margin: 4px; border: 1px solid #777; padding: 3px; }
#ubbody input.defaultbutton	{ padding: 0.4em 1em; }
#ubbody textarea.default	{ margin: 4px; border: 1px solid #777; padding: 3px; }
#ubbody select.default		{ margin: 4px; border: 1px solid #777; padding: 1px; }
#ubbody input.text { width: 120px; }
#ubbody textarea.default { width: 300px; height: 150px; }

#ublogin { position: relative; width: 260px; margin: 20px auto 0 auto; padding: 12px; }
#ublogin th { font: bold 1em/2.4em Verdana,sans-serif; text-align: center; position: relative; }
#ublogin .ub-header-icon__wait { display: block; position: absolute; left: 0; top: 0; height: 100%; font-size: 1.3em; line-height: 2em; padding: 0 0.7em; background: #c3c3c3; border-right: 1px solid #999; }
#ublogin input[type="text"], #ublogin input[type="password"] { width: 120px; }
#ublogin td { white-space: nowrap; padding: 0.9em 1em; text-align: left; }
#ublogin td.label { padding-right: 2px; vertical-align: middle; }
#ublogin td.ubfield { text-align: right; }
#ublogin td.ubbutton { text-align: center; vertical-align: middle; }
#ublogin table { width: 100%; border-collapse: collapse; text-align: left; }

p#manage_users_paid_accounts_note { margin: 0 auto 20px auto; font-style: italic; }
input.varprice { width: 60px; }
#join_paid_group td { max-width: 300px; }
#joinpaidgroup_output { font-style: italic; }

#userform { text-align: left; max-width: 450px; border: 0 !important; margin: 10px auto; }
#userform table { border-collapse: collapse; text-align: left !important; max-width: 450px; margin-top: 25px; }
#userform th { padding: 1em; text-align: center; }
#userform td { padding: 1em; }
#userform input.text, #userform textarea.default { width: 180px; }
#userform .label { width: 49%; }
#userform td.ubbutton { text-align: center; vertical-align: middle; }
#userform td.note { font-style: italic; }
#userform #pw_strength { font-style: italic; margin-left: 5px; white-space: nowrap; }






#payment-page { width: 40%; margin: 20px auto; padding: 2px; background: #efefef; color: #000; }
#payment-page div { margin: 0 auto; padding: 15px; }

.paysum { overflow: auto; display: table; margin: 1em auto 2em auto; }
.paysum .year-title { font: bold 1.4em sans-serif; border: 1px solid #aaa; background: #e6e6e6; padding: 0.5em; }
.paysum .yearly { float: left; text-align: left !important; max-width: 30%; margin-right: 2em; border: 1px solid #bbb; background: #efefef; white-space: nowrap; }
.paysum .yearly td { padding: 0.5em; }
.paysum .yearly .label { font-weight: bold; }
.paysum .monthly { float: left; max-width: 65%; border: 1px solid #bbb; background: #efefef; }
.paysum .monthly th { padding: 0.5em; }
.paysum .monthly td { padding: 0.5em; text-align: right; }
.paysum .monthly .odd td  { background: #f9f9f9; }
.paysum .monthly .even td { background: #efefef; }

#showusers tr.pending  { color: #999; }
#showusers tr.disabled { color: #999; }
#showusers tr.usersfooter { text-align: left; border-bottom: none !important; }
#showusers .usersfooter button { margin-right: 0.1em; }
#showusers #adduser_btn { margin-left: 2em; }
#showusers #adduser_btn .fa { margin-right: 0.1em; color: #4a7; }
#showusers #deleteselected_btn .fa { margin-right: 0.1em; color: #a33; }
.table-footer-info { font-style: italic; margin: 0 auto 20px auto; }
#acct_list_filter_div { margin: 20px auto 10px auto; font-weight: bold; }
#acct_list_filter_div input[type="text"] { width: 100px; }

#ub_csv_import_step2 table { margin: 15px auto; text-align: right; }
#ub_csv_import_step2 table td { vertical-align: top; padding: 4px 14px; }
#ub_csv_import_step2 table .submit_button_row { text-align: center; }

#ub_csv_export { width: 400px; margin: 0 auto; }
#ub_csv_export table { width: 100%; margin: 20px auto; text-align: left; border-collapse: collapse; border: 1px solid #777; }
#ub_csv_export table th { padding: 7px; background-color: #ddd; }
#ub_csv_export table td { padding: 7px; background-color: #eee; vertical-align: top; }

.def { border-bottom: 1px dotted; }

.ub-header-icon { color: #57c; }

#formmessage
{
	border: 1px solid #aaa;
	box-shadow: 0px 0px 4px #999;
	background: #ffde00;
	color: #333;
	width: 300px;
	margin: 1em auto;
	padding: 5px;
	text-align: center;
	font-size: 12pt;
}


#profileimagepage table.profile_image { border-top: 1px solid #ddd; width: 96%; margin: 0 auto 30px auto; border-collapse: collapse; }
#profileimagepage .profile_image tr:hover { background: #fff858; }
#profileimagepage .profile_image td { padding: 20px; border-bottom: 1px solid #ddd; }
#profileimagepage .first_profile_image { }
#profileimagepage .profile_image .filename { font-weight: bold; }
#profileimagepage .profile_image .resizedetails { text-align: left; }
#profileimagepage .profile_image .deletelink { text-align: right; }
#profileimagepage .profile_image .deletelink a { display: block; margin-bottom: 20px; }
#profileimagepage .profile_image .thumbnail img { border: 1px solid #000; }
#profileimagepage .profile_image .noimage { font-style: italic; }

#upload_profile_image_form { border-top: 1px solid #ddd; width: 96%; margin: 0 auto; overflow: auto; }
#upload_profile_image_form div#form_intro { margin: 20px 0 20px 20px; float: left; text-align: left; width: 46%; }
#upload_profile_image_form div#form_controls { margin: 20px 20px 20px 0; float: right; text-align: right; width: 46%; }
#upload_profile_image_form div#form_controls input { }
#upload_profile_image_form:hover { background: #fff858; }

#profilepage .enc_tbl { width: 60%; }
#profilepage .fieldname { width: 50%; font-weight: bold; }
#profilepage .fieldvalue { width: 50%; }
#profilepage td { text-align: left; }
#profilepage .basic_info { }
#profilepage .basic_image { text-align: right; vertical-align: top; }
#profilepage .basic_image img { border: 1px solid #888; }
#profilepage .basic_info { text-align: left; }
#profilepage .basic_info .name { font-weight: bold; font-size: 18pt; }
#profilepage .basic_info .username { }
#profilepage .basic_info .email { }

#memberdirectorypage .enc_tbl { width: 60%; }
#memberdirectorypage td { text-align: left; }
#memberdirectorypage .userimage { text-align: right; }
#memberdirectorypage .userimage img { border: 1px solid #888; }

#enc_apps_note a { text-decoration: underline !important; }

#humantest_row { text-align: center; }
#enc-humantest { }

.paid_groups_list { border-collapse: collapse; }

#managepagelock .page { text-align: left; }
.ub_lock_popup { overflow: scroll; }
.ub_lock_popup .encpopup_inner { margin-top: 5%; }
.ub_lock_popup input[type="checkbox"] { margin: 0.5em; }
.ub_lock_popup input[type="button"] { margin: 1em 1em 0em 0; }
#dirlock_excl_exts { display: block; margin: 0.6em 0; width: 90%; }
#managedirlock .dir { text-align: left; }
.intro { font-style: italic; margin: 10px auto 5px auto; max-width: 500px; }
.intro-left { font-style: italic; margin: 10px auto 5px auto; text-align: left; }


/* Do not change or remove these "_rules" lines: */


/* %%custom_css_rules%% */


/* %%shared_css_rules%% */


/* %%light_or_dark_rules%% */


`;












$PREF{css_light} = qq`

.altcolor2 { color: #666; }

#encsubtitle, .encsubtitles { color: #777; }

#ublogin table { border: 1px solid #888; color: #575757; box-shadow: 0 0 15px #777; }
#ublogin th { background: #e0e0e0; color: #333; border-bottom: 1px solid #999; }
#ublogin tr { background: #fff; }
#ublogin tr:hover { background: #efefef; }
#ublogin .ub-header-icon { color: #333; }


#ubbody .listug-letters { font-size: 120%; font-weight: bold; text-align: center; }
#ubbody .listug-letters a { padding: 4px; color: #507090; border: 0; }
#ubbody .listug-letters a:hover { background: #507090; color: #fff; text-decoration: none; border: 0; }
#ubbody .listug-letters a.current { text-decoration: underline; }

#showusers tr.usersfooter td { background: #ccc; border-top: 1px solid #999; } 

#userform table { border: 1px solid #888; box-shadow: 0 0 15px #777; }
#userform table th { background: #e0e0e0; color: #333; border-bottom: 1px solid #999; }

.paid_group_details { background: #f0f0f0 !important; }
.paid_groups_list tr.last { border-bottom: 1px solid #bbb; }

.pagedirlock-title-icon { display: inline-flex; align-items: center; margin-right: 0.5em; padding: 0.3em 0.5em 0.2em 0.5em; background: #e6e6e6; border-radius: 0.6em; border: 1px solid #bbb; box-shadow: 0 0 3px #777; }
.pagedirlock-title-icon i:first-child { font-size: 1.0em; margin-right: 0.3em; }
.pagedirlock-title-icon i:last-child { font-size: 1.3em; }

.dirlock-title-icon i:first-child { font-size: 1.2em; margin-right: 0.3em; }

`;












$PREF{css_dark} = qq`

#ubbody { background-color: black; color: white; }
#ubbody a { color: #a6a6a6; }
#ubbody .pagesubtitle { color: #aaa; }
#ubbody input.default { border: 1px solid #666; background: #000; color: #bbb; }
#ubbody table td { color: #8f8f8f; }


#ublogin { position: relative; width: 260px; margin: 20px auto 0 auto; padding: 12px; }
#ublogin table { width: 100%; border: 1px solid #666; border-collapse: collapse; text-align: left; }
#ublogin th { background: #555; color: #fff; padding: 8px; font: bold 8pt sans-serif; text-align: center; }
#ublogin th { font: bold 9pt Verdana,sans-serif; border-bottom: 1px solid #555; }
#ublogin table td { white-space: nowrap; padding: 7px; text-align: left; color: #fff; }
#ublogin td.label { padding-right: 2px; vertical-align: middle; }
#ublogin td.ubfield { text-align: right; }
#ublogin tr { background: #333; }
#ublogin tr:hover { background: #444; }
#ublogin td.ubbutton { text-align: center; vertical-align: middle; }
#ublogin .ub-header-icon { color: #333; }
#ublogin .altcolor2 { color: #ccc; }


#ubbody .listug-letters { font-size: 120%; font-weight: bold; text-align: center; }
#ubbody .listug-letters a { padding: 4px; color: #fff; border: 0; }
#ubbody .listug-letters a:hover { background: #fff; color: #000; text-decoration: none; border: 0; }
#ubbody .listug-letters a.current { text-decoration: underline; }

#showusers tr.usersfooter td { background: #555; } 

#userform table { border: 1px solid #666; }

.paid_group_details { background: #f0f0f0; }


`;












$PREF{css_extra} = qq`



`;








############################################################################
# Here you can modify UserBase's login form template.
#
$PREF{hide_app_pagetitle_on_login_page}	= 'yes';
$PREF{hide_app_subtitle_on_login_page}	= 'yes';
$PREF{login_form_template}		= qq`
%%special_message%%
<form method="post" action="$ENV{SCRIPT_NAME}?action=validate%%whence%%" id="ublogin">
<table>
	<tr class="header"><th colspan="2">
	<i class="ub-header-icon fa fa-lock"></i> %TEXT{title_for_login_form} <span class="altcolor2">Login</span>
	</th></tr>

	<tr class="odd">
	<td class="label">%PREF{username_label}:</td>
	<td class="ubfield"><input type="text" name="%PREF{userbase_user_fieldname}" id="ubun" maxlength="4" /></td>
	</tr>

	<tr class="even">
	<td class="label">Password:</td>
	<td class="ubfield"><input type="password" name="%PREF{userbase_pass_fieldname}" maxlength="4" /></td>
	</tr>

	%%%if-rememberme%%%
	<tr class="odd">
	<td colspan="2" style="text-align: center;"><input type="checkbox" name="remember_me" id="ub_remember_me" checked="checked" />
	<label for="ub_remember_me">Remember me for %PREF{num_days_rememberme_cookie_lasts} days</label>
	</td>
	</tr>
	%%%end-rememberme%%%

	%%%if-restrictip%%%
	<tr class="even">
	<td colspan="2" style="text-align: center;"><input type="checkbox" name="restrict_ip" id="ub_restrict_ip" checked="checked" />
	<label for="ub_restrict_ip">Use extra security (<a href="#" onclick="alert('Restricts your session to your IP address.'); return false">explain</a>)</label>
	</td>
	</tr>
	%%%end-restrictip%%%

	<tr class="odd">
	<td colspan="2" class="ubbutton">
	<input type="hidden" name="ref" value="$ENV{HTTP_REFERER}" />
	<input type="hidden" name="qstr" value="$ENV{QUERY_STRING}" />
	<input type="hidden" name="loginreturn" value="%%loginreturn%%" />
	<input type="submit" value="Log in" class="defaultbutton" /></td>
	</tr>
</table>
</form>
`;








############################################################################
# Here you can modify UserBase's login/logout link template; this is the
# link that is displayed when ?format=justlink is passed on the URL.  You
# can also adjust the login status template; this is what's displayed when
# you pass ?format=loginstatus on the URL.  Note that these are unused by
# UserBase in its normal operation, and in most installations they're not
# necessary, because UserBase handles all of this automatically within its
# own pages.  These are only needed if you want to display these links and
# status messages within your own pages outside of UserBase.
#
$PREF{login_logout_link_template___login}		=  qq`Welcome, guest. (<a href="%PREF{login_url}">Login</a> | <a href="%PREF{login_url_qsready}?action=signup">Register</a>)`;
$PREF{login_logout_link_template___logout}		=  qq`Welcome, %PREF{logged_in_username}. (<a href="%PREF{login_url}">My Account</a> | <a href="%ENV{SCRIPT_NAME}?ublogout">Logout</a>)`;
$PREF{login_status_template___loggedin}			=  qq`You are logged in as %PREF{logged_in_username}.`;
$PREF{login_status_template___loggedout}		=  qq`You are logged out.`;








############################################################################
# Here you can modify UserBase's mini login form template; this version
# of the login form is displayed when ?format=mini is passed on the URL.
# You can also specify the "mainmenu" text, which appears in place of the
# mini login form when the user is already logged in.
#
$PREF{login_form_template__mini} =  qq`
<form method="post" action="$ENV{SCRIPT_NAME}?format=mini&amp;action=validate%%whence%%" id="ubloginmini">
<span style="font-family: monospace;">%PREF{username_label}:</span>
<input type="text" class="default text" name="%PREF{userbase_user_fieldname}" id="ubun" />

<br /><span style="font-family: monospace;">Password:</span>
<input type="password" class="default text" name="%PREF{userbase_pass_fieldname}" />

%%%if-rememberme%%%
<br /><input type="checkbox" name="remember_me" />Remember me for %PREF{num_days_rememberme_cookie_lasts} days
%%%end-rememberme%%%

%%%if-restrictip%%%
<br /><input type="checkbox" name="restrict_ip" />Use extra security (<span class="def" title="restricts your session to your IP address">explain</span>)
%%%end-restrictip%%%

<input type="hidden" name="ref" value="$ENV{HTTP_REFERER}" />
<input type="hidden" name="qstr" value="$ENV{QUERY_STRING}" />

<br /><input type="submit" value="Log in" class="defaultbutton" />
<span id="mini_signup_link">&nbsp;&nbsp;Or, <a href="%PREF{login_url_qsready}action=signup">sign up</a></span>

</form>
`;



$PREF{mainmenu_template__mini} = qq`
<div>User %%username%% logged in &#8211; 
<a href="$PREF{login_url}">Options</a> &#8211; 
<a href="$ENV{SCRIPT_NAME}?ublogout">Logout</a></div>
`;











############################################################################
# Here you can modify UserBase's signup/adduser/edituser form template.
# This single form functions as the signup form, the edit-account form,
# and the administrator's add-new-user form, so keep that in mind when
# editing the template.  You can move sections around and edit the
# sections, but in most cases it's best to avoid deleting entire sections.
#
$PREF{user_form_title___user_signing_up}	= qq`Sign Up`;
$PREF{user_form_title___admin_adding_user}	= qq`Add New User`;
$PREF{user_form_title___subadmin_adding_user}	= qq`Add New User`;
$PREF{user_form_title___editing_account}	= qq`View or Edit Account Information`;
$PREF{user_form_template}			=  qq`

	%%%if-forcepwchng%%%
	<p style="text-align: center;">You must change your password now.</p>
	%%%end-forcepwchng%%%

	<!-- don't change anything about the form tag except possibly the class. -->
	<form method="post" action="%%post_url%%" id="userform" name="userform">
	<input type="hidden" name="loggedin_user_details" id="loggedin_user_details" value="%%loggedin_user_details%%" /><!-- obviously not to be used for anything security-related, but useful for showing/hiding fields via JS in custom configurations, etc. -->
	%%hidden_signup_input%%
	%%user_form_field_sections%%
	<input type="hidden" name="qstr" value="$ENV{QUERY_STRING}" />
	</form>

`;


$TEXT{user_form_section_header___signup}	= qq`Sign Up`;
$TEXT{user_form_section_header___adminadd}	= qq`Add New User`;
$TEXT{user_form_section_header___edit}		= qq`Account Information`;
$PREF{user_form_section_header_template}	= qq`

	<i class="ub-header-icon fa fa-user"></i> %TEXT{title_for_user_form} 
	<span class="altcolor2">%%user_form_section_header_text%%</span>
`;


$PREF{user_form_fields_template}		= qq`

<table id="%%section_css_id%%">

	<tr class="header"><th colspan="2">%%user_form_section_header%%</th></tr>


	%%%if-show_builtin_fields%%%


		<tr>
		<td class="label">%PREF{username_label}:</td>
		<td class="ubfield"><input type="text" name="username" class="default text required %%emailformat%%" maxlength="%PREF{max_username_length}" value="%%username%%" %%username_readonly%% /></td>
		</tr>


		%%%if-use_builtin_realname_field%%%
			<tr>
			<td class="label">%PREF{name_label}:</td>
			<td class="ubfield"><input type="text" name="realname" class="default text required" maxlength="%PREF{max_realname_length}" value="%%realname%%" /></td>
			</tr>
		%%%end-use_builtin_realname_field%%%


		%%%if-use_builtin_email_field%%%
			<tr id="ub_email">
			<td class="label">$PREF{email_label}:</td>
			<td class="ubfield"><input type="text" name="email" class="default text %%email_field_required%%" maxlength="%PREF{max_emailaddr_length}" value="%%email%%" /></td>
			</tr>
		%%%end-use_builtin_email_field%%%


		%%%if-show_password_fields%%%

			%%%if-currentpass_needed%%%
				<tr>
				<td class="label">Current Password<br />(only if changing):</td>
				<td class="ubfield"><input type="password" name="oldpw" class="default text" maxlength="%PREF{max_password_length}" /></td>
				</tr>
			%%%end-currentpass_needed%%%


			<tr>
			<td class="label">
			%%%ifelse-editing_account%%% New Password: %%%else%%% Password: %%%endelse-editing_account%%%
			</td>
			<td class="ubfield">
				<input type="password" name="pw1" id="ubpw1" class="default text %%new_password_required%%" maxlength="%PREF{max_password_length}" />
				<div id="pw_strength"></div>
			</td>
			</tr>


			<tr>
			<td class="label">
			%%%ifelse-editing_account%%% New Password, Again: %%%else%%% Password, Again: %%%endelse-editing_account%%%
			</td>
			<td class="ubfield"><input type="password" name="pw2" id="ubpw2" class="default text %%new_password_required%%" maxlength="%PREF{max_password_length}" /></td>
			</tr>


			<tr><td class="note" colspan="2">Strong passwords are at least 14 characters long, with a mix of upper case, lower case, numbers, and special characters.</td></tr>

		%%%end-show_password_fields%%%


		%%%if-show_account_locks%%%
			<tr>
			<td class="label">
				Account Locked <span style="font-weight: normal;">(this is the <br />"too many failed logins" lock;

				%%%ifelse-lock_expires_automatically%%%
					it <br />auto-unlocks after %PREF{failed_logins_within_N_secs_count_towards_lock} seconds)</span>:
				%%%else%%%
					it <br />requires manual unlocking by an <br />admin here)</span>:
				%%%endelse-lock_expires_automatically%%%
			</td>
			<td class="ubfield"><input type="checkbox" name="account_locked" %%account_locked_checked%% /></td>
			</tr>

			<tr>
			<td class="label">Account Disabled <span style="font-weight: normal;">(this can only <br />be changed here, by an admin)</span>:</td>
			<td class="ubfield"><input type="checkbox" name="account_disabled" %%account_disabled_checked%% /></td>
			</tr>
		%%%end-show_account_locks%%%


		%%%if-show_force_pwchng%%%
			<tr>
			<td class="label">Force Password Change:</td>
			<td class="ubfield"><input type="checkbox" name="forcepwchng" %%forcepwchng_checked%% /></td>
			</tr>
		%%%end-show_force_pwchng%%%


		%%terms_of_service%%


		%%grouplist%%


	%%%end-show_builtin_fields%%%



	%%%if-show_customfields%%%
	%%%template:customfields%%%
	<tr>
	<td class="label" id="ub_%%fieldname%%_label">
		%%fieldlabel%%
	</td>
	<td class="ubfield" id="ub_%%fieldname%%_field">

		%%%ifelse-readonly%%%

			%%value%%
			<!-- Also include a hidden field containing the value, so any Field Actions (showing/hiding  -->
			<!-- fields based on the user's field entries, etc) depending on this field will still work. -->
			<input type="hidden" name="%%fieldname%%" id="%%css_id%%" value="%%value%%" />

		%%%else%%%

			%%%if-freeformsingle%%%
				<input type="text" name="%%fieldname%%" id="%%css_id%%" maxlength="%%fieldmax%%" class="default text %%required%%" value="%%value%%" />
			%%%end-freeformsingle%%%

			%%%if-freeformmulti%%%
				<textarea name="%%fieldname%%" id="%%css_id%%" class="default text %%required%%">%%value%%</textarea>
			%%%end-freeformmulti%%%

			%%%if-dropdown%%%
				<select name="%%fieldname%%" id="%%css_id%%" class="default text %%required%%">
					%%%if-mandatory%%%
						<option value=""></option>
					%%%end-mandatory%%%
					%%%template:dropdown%%%
						<option value="%%submitted_value%%" %%dropdown_selected%%>%%displayed_value%%</option>
					%%%end-template:dropdown%%%
				</select>
			%%%end-dropdown%%%

			%%%if-checkbox%%%
				<input type="checkbox" name="%%fieldname%%" id="%%css_id%%" class="checkbox" %%checkbox_checked%% />
			%%%end-checkbox%%%

			%%%if-radio%%%
				%%%template:radio%%%
					<input type="radio" name="%%fieldname%%" id="%%css_id%%" class="%%required%%" value="%%submitted_value%%" %%radio_checked%% />
					<label for="%%css_id%%">%%displayed_value%%</label>
					<br />
				%%%end-template:radio%%%
			%%%end-radio%%%

		%%%endelse-readonly%%%

	</td>
	</tr>
	%%%end-template:customfields%%%
	%%%end-show_customfields%%%



	%%%if-show_submit_button%%%
		%%%if-enable_human_test%%%
		%%%if-user_signing_up%%%
			%%%ifelse-human_test_is_invisible%%%
				%%human_test_hash%%
				%%human_test_code%%
				%%human_test_form%%
			%%%else%%%
				<tr id="humantest_row">
				<td colspan="2">
				%TEXT{Enter_the_numbers_in_the_box_below}
				%%human_test_hash%%
				%%human_test_form%%
				</td>
				</tr>
			%%%endelse-human_test_is_invisible%%%
		%%%end-user_signing_up%%%
		%%%end-enable_human_test%%%

		<tr>
		<td colspan="2" class="ubbutton">
		<input type="hidden" name="userid" value="%%user_id%%" />
		<input type="hidden" name="loginreturn" value="%%loginreturn%%" />
		<input type="hidden" name="autogroup" value="%URL{autogroup}" />
		<input type="hidden" name="is_signup" id="is_signup" value="%%%if-user_signing_up%%%1%%%end-user_signing_up%%%" />
		<input type="button" id="%PREF{submitbutton_id}" value="%%%if-user_signing_up%%%Sign Up%%%end-user_signing_up%%%%%%if-admin_adding_user%%%%TEXT{Add_User}%%%end-admin_adding_user%%%%%%if-editing_account%%%Update Information%%%end-editing_account%%%" class="defaultbutton" onclick="submit_user_form()" />
		</td>
		</tr>
	%%%end-show_submit_button%%%



</table>

%%%if-human_test_is_invisible%%%
<div id="ht_is_invisible"></div>
%%%end-human_test_is_invisible%%%

`;



$PREF{user_form___terms_of_service} = qq`

	<tr>
	<td class="label">
		<p>Terms of Use:</p>
		<p>By signing up for an account, you agree not to do anything bad to our site, blah blah blah...</p>
	</td>
	<td class="ubfield"><input type="checkbox" name="agreetoterms" id="agreetoterms" /></td>
	</tr>

`;



$PREF{user_form___grouplist} = qq`

	<tr>
	<td class="label" style="vertical-align: top;">Group Memberships:</td>
	<td class="ubfield groups">
		%%%template:grouplist%%%
		<input type="checkbox" name="group-%%group%%" id="group-%%group%%" class="ub_group_checkbox %%paidgroupcheckbox%%" %%checked%% %%disabled%% />
		<label for="group-%%group%%">%%group_label%%</label>
		<br /><br />
		%%%end-template:grouplist%%%
	</td>
	</tr>

`;










############################################################################
# Template for the individual user profile pages.
#
$PREF{show_builtin_fields_with_custom_fields_in_profile}= 'no';
$PREF{section_label_for_sections_without_labels}	= 'Additional Details';
$PREF{user_profile_page_title}				= qq`%%username%%'s Profile`;
$PREF{user_profile_page_template}			= qq`

<div class="enc_tbl">
<table class="basic_info">
<tr><th colspan="2">Basic Information</th></tr>
<tr><td class="name">%%name%%</td><td class="basic_image">%%smallest_profile_image_html%%</td></tr>
<tr><td colspan="2" class="username">"%%username%%"</td></tr>
<tr><td colspan="2" class="email">%%email%%</td></tr>
</table>
</div>

%%default_fields_block%%

`;


$PREF{user_profile_page_default_fields_block_template} = qq`

<div class="enc_tbl">
<table>
<tr><th colspan="2">%%section_label%%</th></tr>
%%%template:field%%%
	<tr>
	<td class="fieldname">%%fieldlabel%%</td>
	<td class="fieldvalue">%%fieldvalue%%</td>
	</tr>
%%%end-template:field%%%
</table>
</div>

`;










############################################################################
# Template for the member directory.
#
$PREF{show_builtin_fields_with_custom_fields_in_directory}= 'no';
$PREF{member_directory_page_title}			= qq`Member Directory`;
$PREF{num_members_per_page_on_member_directory}		= 5;
#
# Add %%default_fields_block%% somewhere within this page template if you
# want the member directory page to show custom form field values.
#
$PREF{member_directory_page_template}			= qq`

%%member_directory_list%%

`;


$PREF{member_directory_list_template}			= qq`

<div class="enc_tbl">
<table class="basic_info">
<tr><th colspan="2">%%username%%</th></tr>
<tr><td class="name">%%name%%<br /><a href="mailto:%%email%%">%%email%%</a><br /><br /><a href="%%profile_link%%">View Profile</a></td><td class="userimage">%%smallest_profile_image_html%%</td></tr>
</tr>
</table>
</div>

`;


$PREF{member_directory_page_default_fields_block_template} = qq`

<div class="enc_tbl">
<table>
<tr><th colspan="2">%%section_label%%</th></tr>
%%%template:field%%%
	<tr>
	<td class="fieldname">%%fieldlabel%%</td>
	<td class="fieldvalue">%%fieldvalue%%</td>
	</tr>
%%%end-template:field%%%
</table>
</div>

`;









# PREFs Section C: Common Settings (used by multiple Encodable apps)
##########################################################################UB
# Text strings:
#
$TEXT{Access_denied_}						= qq`Access denied.`;
$TEXT{Admin_Alerts}						= qq`Admin Alerts`;

$TEXT{boolean_false_string}					= 'no';
$TEXT{boolean_true_string}					= 'yes';

$TEXT{database_create_button}					= qq`Add new %%itemname%%`;
$TEXT{database_create_button_2}					= qq`Save new %%itemname%%`;
$TEXT{database_delete_successful}				= qq`Successfully deleted the %%itemname%%.`;
$TEXT{database_deleter_title}					= qq`Or you can delete this %%itemname%%:`;
$TEXT{database_deleter_checkbox}				= qq`Check this box to confirm that you want to delete the %%itemname%%.`;
$TEXT{database_deleter_button}					= qq`Delete this %%itemname%%`;
$TEXT{database_file_picker_available_files_label}		= qq`Available Files:`;
$TEXT{database_file_picker_choose_button}			= qq`Choose`;
$TEXT{database_file_picker_chosen_files_label}			= qq`Chosen File(s):`;
$TEXT{database_file_picker_no_files_label}			= qq`(none)`;
$TEXT{database_file_picker_remove_button}			= qq`Remove`;
$TEXT{database_file_picker_upload_files_label}			= qq`Attach File(s):`;
$TEXT{database_image_picker_available_images_label}		= qq`Available Images:`;
$TEXT{database_image_picker_choose_button}			= qq`Choose`;
$TEXT{database_image_picker_chosen_images_label}		= qq`Chosen Image(s):`;
$TEXT{database_image_picker_no_images_label}			= qq`(none)`;
$TEXT{database_image_picker_remove_button}			= qq`Remove`;
$TEXT{database_image_picker_upload_images_label}		= qq`Upload New Image(s):`;
$TEXT{database_save_button}					= qq`Save changes`;
$TEXT{database_search_button}					= qq`Search`;
$TEXT{database_toggle_cols_button}				= qq`Show more fields`;
$TEXT{database_toggle_cols_reset}				= qq`Show default fields`;
$TEXT{days}							= qq`days`;
$TEXT{Delete}							= qq`Delete`;
$TEXT{Delete_Selected}						= qq`Delete Selected`;

$TEXT{Edit}							= qq`Edit`;
$TEXT{Enter_the_password}					= qq`Enter your password:`;
$TEXT{Error__failed_human_test__please_try_again_}		= qq`Error: failed human test; please try again.`;
$TEXT{Error_input_not_alnum}					= qq`Error: field "%%encfieldname%%" must contain only letters and numbers.`;
$TEXT{Error_input_not_numeric}					= qq`Error: value for field "%%encfieldname%%" must be numeric.`;
$TEXT{Error_input_not_word}					= qq`Error: field "%%encfieldname%%" must contain only letters, numbers, and underscores.`;
$TEXT{Error_input_null}						= qq`Error: field "%%encfieldname%%" cannot be blank.`;
$TEXT{Error_input_too_large}					= qq`Error: value for field "%%encfieldname%%" cannot exceed %%max%%.`;
$TEXT{Error_input_too_long}					= qq`Error: length of input for field "%%encfieldname%%" cannot exceed %%max%% character(s).`;
$TEXT{Error_input_too_short}					= qq`Error: length of input for field "%%encfieldname%%" cannot be less than %%min%% character(s).`;
$TEXT{Error_input_too_small}					= qq`Error: value for field "%%encfieldname%%" cannot be less than %%min%%.`;

$TEXT{Help}							= qq`Help`;

$TEXT{Keep_me_logged_in_for}					= qq`Keep me logged in for`;

$TEXT{Login}							= qq`Login`;
$TEXT{Logout}							= qq`Logout`;

$TEXT{My_Account}						= qq`My Account`;

$TEXT{no}							= qq`no`;
$TEXT{no_output_from_database}					= qq`<div style="text-align: center; font-style: italic;">(none)</div>`;

$TEXT{password_not_set}						= qq`You must <a href="%%newpw_link%%">set your administrator password</a> first.`;
$TEXT{Please_enter_a_number_}					= qq`Please enter a number.`;
$TEXT{Please_enter_only_letters_}				= qq`Please enter only letters.`;
$TEXT{Please_enter_only_letters_and_numbers_}			= qq`Please enter only letters and numbers.`;
$TEXT{Please_enter_a_valid_email_address_}			= qq`Please enter a valid email address.`;
$TEXT{Please_fill_in_the_required_items_}			= qq`Please fill in the required item(s).`;
$TEXT{Please_wait}						= qq`Please wait`;

$TEXT{Record_deleted_successfully_}				= qq`Record deleted successfully.`;

$TEXT{Select_All}						= qq`Select All`;
$TEXT{Select_None}						= qq`Select None`;
$TEXT{Send_Test_Email}						= qq`Send Test Email`;
$TEXT{sending_please_wait}					= qq`<div style="text-align:center;"><img src="%PREF{app_images_url}/encspin31.gif" style="border:0; width:31px; height:31px;" alt="Sending; please wait..." /></div>`;
$TEXT{Server_Information}					= qq`Server Information`;
$TEXT{Settings}							= qq`Settings`;
$TEXT{Show_Installed_Perl_Modules}				= qq`Show Installed Perl Modules`;

$TEXT{Test_Email_Setup}						= qq`Test Email Settings`;
$TEXT{The_password_you_entered_is_incorrect___}			= qq`The password you entered is incorrect.<br />Go back and try again.`;

$TEXT{wcfg_not_saved}						= qq`not saved yet...`;
$TEXT{WebConfig}						= qq`WebConfig`;

$TEXT{yes}							= qq`yes`;









# PREFs Section C: Common Settings (used by multiple Encodable apps)
############################################################################
# Styling:
#
$PREF{css_shared} = qq`

#enc_vis_id_setter { position: absolute; left: -5500px; height: 0; overflow: hidden; }

/* TODO: enc_drop_shadow is unused at least in FC and UB as of early 2016; remove it? */
.enc_drop_shadow { position: relative; padding: 12px; }
.enc_drop_shadow .sh1 { background: url(%PREF{app_images_url}/shad01c.png); top: 0; left: 0;	left: 22px; right: 22px; height: 12px; }
.enc_drop_shadow .sh2 { background: url(%PREF{app_images_url}/shad02c.png); top: 0; right: 0;	top: 22px; bottom: 22px; width:  12px; }
.enc_drop_shadow .sh3 { background: url(%PREF{app_images_url}/shad03c.png); bottom: 0; left: 0;	left: 22px; right: 22px; height: 12px; }
.enc_drop_shadow .sh4 { background: url(%PREF{app_images_url}/shad04c.png); top: 0; left: 0;	top: 22px; bottom: 22px; width:  12px; }
.enc_drop_shadow .sh5 { background: url(%PREF{app_images_url}/shad05c.png); top: 0; left: 0; }
.enc_drop_shadow .sh6 { background: url(%PREF{app_images_url}/shad06c.png); top: 0; right: 0; }
.enc_drop_shadow .sh7 { background: url(%PREF{app_images_url}/shad07c.png); bottom: 0; right: 0; }
.enc_drop_shadow .sh8 { background: url(%PREF{app_images_url}/shad08c.png); bottom: 0; left: 0; }
.enc_drop_shadow .sh1, .enc_drop_shadow .sh2, .enc_drop_shadow .sh3, .enc_drop_shadow .sh4 { position: absolute; }
.enc_drop_shadow .sh5, .enc_drop_shadow .sh6, .enc_drop_shadow .sh7, .enc_drop_shadow .sh8 { position: absolute; width: 22px; height: 22px; }

#db_viewer_table a:hover	{ text-decoration: underline !important; }
#database_deleter .enc_tbl	{ max-width: 780px; }
.enc_dbcreate_tbl_vert		{ max-width: 780px; }
.enc_dbedit_tbl_vert		{ max-width: 780px; }
.enc_dbview_tbl_vert		{ max-width: 780px; }
.enc_dbview_tbl_vert td		{ text-align: left; }
.enc_dbview_tbl_vert td.addnew	{ text-align: center; }
.enc_dbview_thumb		{ width: 150px; }

.header_input_notes { display: inline-block; font-style: italic; font-weight: normal; margin-left: 8px; }
#encdb_showhide_links { display: none; }
#toggle_all_cols { margin-right: 2em; }
.encdb_content_link { text-decoration: underline !important; }
.database_subtitle { font-weight: bold; font-size: 11pt; margin-top: -14px; color: #999; }
.database_header_note { font-style: italic; }
.database_header_note a { text-decoration: underline !important; }
#db_view_controls { margin-bottom: -4px !important; }

.encdb_imgpkr_wrapper .empty_placeholder { margin-top: 20px; font-style: italic; }
.encdb_imgpkr_chosen_label { font-weight: bold; font-size: 11pt; }
.encdb_imgpkr_all_label { font-weight: bold; font-size: 11pt; margin-top: 20px; }
.encdb_imgpkr_upload_label { font-weight: bold; font-size: 11pt; margin-top: 20px; }
.encdb_imgpkr_chosen, .encdb_imgpkr_all, .encdb_imgpkr_upload
{
	margin-top: 10px;
	min-height: 50px;
	max-height: 300px;
	overflow: auto;
	padding-left: 10px;
}
.encdb_imgpkr_image_block
{
	overflow: auto;
	margin: 10px 0;
}
.encdb_imgpkr_image_block .imgpkr_text
{
	float: left;
	padding-top: 10px;
}
.encdb_imgpkr_image_block .imgpkr_thumb		{ float: left; }
.encdb_imgpkr_image_block img			{ margin-right: 10px; }
.encdb_imgpkr_upload input			{ margin-top: 15px; }


.encdb_filpkr_wrapper .empty_placeholder { margin-top: 20px; font-style: italic; }
.encdb_filpkr_chosen_label { font-weight: bold; font-size: 11pt; }
.encdb_filpkr_all_label { font-weight: bold; font-size: 11pt; margin-top: 20px; }
.encdb_filpkr_upload_label { font-weight: bold; font-size: 11pt; margin-top: 20px; margin-top: 4px; }
.encdb_filpkr_chosen, .encdb_filpkr_all, .encdb_filpkr_upload
{
	margin-top: 10px;
	min-height: 50px;
	max-height: 300px;
	overflow: auto;
	padding-left: 10px;
}
.encdb_filpkr_file_block
{
	overflow: auto;
	margin: 10px 0;
}
.encdb_filpkr_file_block .filpkr_text
{
	float: left;
	padding-top: 10px;
}
.encdb_filpkr_file_block .filpkr_thumb		{ float: left; }
.encdb_filpkr_file_block img			{ margin-right: 10px; }
.encdb_filpkr_upload input			{ margin-top: 15px; }


.enc_tablestyle_b { margin: 25px auto; border-width: 1px; border-style: solid; border-collapse: collapse; }
.enc_tablestyle_b th { padding: 10px; }
.enc_tablestyle_b td { padding: 10px; }
.enc_tablestyle_b tr { border-top-width: 1px; border-top-style: solid; }

.enc_box_a { margin: 25px auto; border-width: 1px; border-style: solid; padding: 10px; max-width: 400px; }

.hidden_by_default { display: none; }
.encwarning { color: red; }
#admin_alert_icon { padding-left: 2px; vertical-align: -20%; }

#pw_strength { font-style: italic; white-space: nowrap; }

#webconfig_page { text-align: left; max-width: 700px; margin: 10px auto; }
#webconfig_buttons { text-align: center; }
#webconfig_buttons a { outline: none; position: relative; color: #222; box-shadow: 0px 1px 1px #ddd; text-decoration: none; display: inline-block; padding: 0.3em 0.7em; margin: 0 0 1em 1em; border: 1px solid #999; border-radius: 0.2em; background: #eee; }
#webconfig_buttons a:hover { color: #222; box-shadow: 0px 0px 4px #999; text-decoration: none; }
#webconfig_buttons a:active { top: 1px; outline: none; }
#webconfig_instr { display: none; }
.wcfg_shorttextbox { height: 1.4em; }
.wcfg_warning { color: #d71c1c; }
.wcfg_success { color: #30a045; }
.wcfg_section_anchor, .wcfg_section_title { font-weight: bold; }
.prefresult { font-style: italic; display: inline; max-width: 400px; margin-left: 0.3em; }

.webconfig_pref_new { max-width: 340px; margin: 0.3em auto 1em auto; text-align: left; white-space: nowrap; }
.webconfig_pref_new .webconfig_title  { text-align: left; }
.webconfig_pref_new .prefname  { width: 320px; padding: 5px; margin: 3px 1px; }
.webconfig_pref_new .prefname_label  { width: 320px; padding: 5px 10px 5px 0; margin: 3px; display: inline-block; text-align: left; }
.webconfig_pref_new .prefvalue { width: 320px; margin: 3px 1px; vertical-align: top; display: block; }
.webconfig_pref_new .prefresult { white-space: normal; }

.webconfig_pref { max-width: 600px; margin: 10px 10px 0 0; text-align: left; white-space: nowrap; }
.webconfig_pref .prefname_visible { padding: 0px; margin: 0px; display: inline-block; }
.webconfig_pref .prefname_short { min-width: 300px; }
.webconfig_pref .prefname_wide { min-width: 400px; }
.webconfig_pref .prefname_extrawide { min-width: 500px; }
.webconfig_pref .prefname_short, .webconfig_pref .prefname_wide, .webconfig_pref .prefname_extrawide { width: auto; min-width: auto; } /* trying auto instead; neither approach is quite ideal... */
.webconfig_pref .prefname_fixed_wide { min-width: 400px; }
.webconfig_pref .prefvalue { margin: 2px; vertical-align: middle; font: 1.1em/1.1em sans-serif; }
.webconfig_pref .wcfg_shorttextbox { width: 180px; height: 1.1em; }
.webconfig_pref .wcfg_mediumtextbox { display: block; width: 98%; max-width: 400px; height: 5em; margin-left: 0; }
.webconfig_pref .wcfg_largetextbox { display: block; width: 500px; height: 300px; }
.webconfig_pref .prefnote { font-style: italic; margin-bottom: 5px; white-space: normal; display: block; }
.webconfig_pref .prefnote_inline { margin-bottom: 15px; }
.webconfig_pref select.yesno { width: 4em; }

.webconfig_pref_stacked { width: 410px; margin: 20px auto; padding-top: 20px; text-align: left; white-space: nowrap; }
.webconfig_pref_stacked .prefname_visible { padding: 0px; margin: 0px; display: inline-block; }
.webconfig_pref_stacked .prefname_short { width: 300px; }
.webconfig_pref_stacked .prefname_wide { width: 400px; }
.webconfig_pref_stacked .prefname_extrawide { width: 500px; }
.webconfig_pref_stacked .prefvalue { margin: 2px; vertical-align: baseline; }
.webconfig_pref_stacked .wcfg_shorttextbox { width: 180px; height: 1.4em; }
.webconfig_pref_stacked .wcfg_mediumtextbox { width: 400px; height: 5em; }
.webconfig_pref_stacked .wcfg_largetextbox { width: 500px; height: 300px; }
.webconfig_pref_stacked .prefnote { }

#webconfig_common_list .webconfig_pref { margin: 20px auto; padding-top: 20px; }
#webconfig_common_list .prefresult { white-space: nowrap; }

.dbsetup_intro { text-align: left; }
#enc_db_setup .webconfig_pref { }
#enc_db_setup .webconfig_pref .prefname_short { text-align: right; width: 270px; }
#enc_db_setup .prefresult { display: inline; }
#enc_db_setup .prefnote { display: none; }

.emailsetup_intro, #perlmodulespage { text-align: left; }
#enc_email_setup .webconfig_pref .prefname_short { text-align: right; width: 270px; }
#email_test_form #email_button { display: block; margin: 1.5em auto; }
#email_test_output { text-align: left; margin-top: 20px; }


.encfadeout
{
	opacity: 1;
	transition: opacity 0.75s ease-in-out;
	-moz-transition: opacity 0.75s ease-in-out;
	-webkit-transition: opacity 0.75s ease-in-out;
}


`;









# PREFs Section C: Common Settings (used by multiple Encodable apps)
############################################################################
# Styling for light theme:
#
$PREF{css_shared_light} = qq`

.version_info { border-top: 1px solid #bbb; }
.admin_footnote { border-bottom: 1px solid #bbb; margin: 0px auto !important; padding: 10px 0; max-width: 450px; }

#enc_server_info table, #enc_prefs_list table { text-align: left !important; }

.enc_tbl
{
	border: 1px solid #888;
	margin: 10px auto;
	box-shadow: 0 0 15px #777;
}
.enc_tbl table
{
	border-collapse: separate;
	border-spacing: 0;
	border: 0;
	background: #fff;
	width: 100%;
	margin: 0;
	font-size: 8pt;
	text-align: center !important;
}
.enc_tbl table th
{
	padding: 9px;
	background: #e0e0e0;
	color: #333;
	font-weight: bold;
}
.enc_tbl td.verthead
{
	padding: 9px;
	background: #e0e0e0;
	color: #fff;
	width: 30%;
	font-weight: bold !important;
}
.enc_tbl table th a, .enc_tbl td.verthead a, .enc_tbl td.verthead a:visited
{
	color: #333 !important;
	text-decoration: none;
}
.enc_tbl table td a, .enc_tbl table td a:visited
{
	color: #46b !important;
	border: 0;
}
.enc_tbl table td
{
	padding: 7px;
	border-bottom: 0;
}
.enc_tbl table td.verthead, .enc_tbl table td.vertcell
{
	border-bottom: 1px solid #ccc;
}
/* For groups of related fields all in a row, make it easier to see that they're */
/* part of a group, by styling them together a bit differently than the others:  */
.enc_tbl table tr.group_odd td.verthead
{
	background: #406080;
	border-bottom: 1px solid #777;
}
.enc_tbl table tr.group_odd td.vertcell
{
	background: #dddddd;
	border-bottom: 1px solid #777;
}
.enc_tbl table tr
{
	border-bottom: 0;
	background: #efefef;
}
.enc_tbl table tr.odd, .enc_tbl .db_readonly
{
	padding: 4px;
	background: #f3f3f3;
}
.enc_tbl table tr.even
{
	padding: 4px;
	background: #efefef;
}
.enc_tbl table tr:hover
{
	background: #ddd;
}
.enc_tbl table tr:hover td.verthead
{
	background: #ccc;
}
.header_input_notes { color: #777; }

.enc_tbl input.text
{
	width: 200px !important;
	border: 1px solid #555;
	padding: 3px;
}
.enc_tbl input.srch_text
{
	border: 1px solid #555;
	padding: 3px;
}
.enc_tbl textarea
{
	border: 1px solid #555;
	padding: 3px;
}
.enc_tbl textarea.shorttext
{
	width: 300px;
	height: 50px;
}
.enc_tbl textarea.mediumtext
{
	width: 300px;
	height: 80px;
}
.enc_tbl textarea.longtext
{
	width: 300px;
	height: 200px;
}
.enc_tbl .readonly
{
	margin-left: 5px;
}
#database_deleter
{
	margin: 30px 0;
	padding: 0;
}
.database_header_note
{
	max-width: 500px;
	margin: 20px auto;
}
.enc_create_tbl table
{
	/* width: auto; */
}
.enc_create_tbl th, .enc_create_tbl td,
.enc_edit_tbl th, .enc_edit_tbl td
{
	text-align: left;
}
.enc_create_tbl td.button, .enc_edit_tbl td.button
{
	text-align: center;
}

.db_search
{
	border: 1px solid #777;
	padding: 7px;
	margin: 25px auto;
	background: #efefef;
	text-align: left;
	overflow: scroll;
}
.db_search #search_title
{
	font-weight: bold;
	font-size: 10pt;
	color: #555;
	text-decoration: underline;
}
.db_search #search_title:hover
{
	cursor: pointer;
}
.db_search table
{
	width: 100%;
	text-align: left;
	border-collapse: collapse;
	margin: 5px 0;
	white-space: nowrap;
}
.db_search th
{
	background-color: transparent;
}
.db_search a
{
	color: #444 !important;
	text-decoration: none;
}
.db_search input.srch_text
{
	border: 1px solid #555;
	padding: 3px;
	width: 91%;
}
#db_search_form
{
	margin: 0;
	padding: 0;

	/* hidden by default: */
	/*
	position: absolute;
	left: -7000px;
	height: 0;
	overflow: hidden;
	*/
}
#db_search_form_reset_button
{
	
}


.pagelinks
{
	margin-top: 2em;
	cursor: default;
}
.pagelinks .links
{
	display: inline-block;
	margin-top: 10px;
	background: #efefef;
	border: 1px solid #ccc;
	padding: 5px;
}
.pagelinks .links span, .pagelinks .links a
{
	display: block;
	float: left;
	padding: 6px 11px;
	border-right: 1px solid #ccc;
}
.pagelinks .links span.last, .pagelinks .links a.last
{
	border-right: 0;
}
.pagelinks .disabled
{
	cursor: default;
	color: #999;
}
.pagelinks .current
{
	cursor: default;
	color: #999;
}
#ubbody .pagelinks .links a
{
	color: #1E90FF;
	color: #333;
	text-decoration: none;
}
#ubbody .pagelinks .links a:hover
{
	background: #d5d9d3;
	text-decoration: none;
}
.pagelinks .text
{
	line-height: 16pt;
	vertical-align: middle;
	background: #efefef;
	display: inline-block;
	padding: 6px 12px;
	border: 1px solid #ccc;
}
.pagelinks .bookend
{
	display: none;

	font-size: 16pt;
	font-family: serif;
	color: #676767;
	margin: 0 5px;
	vertical-align: top;
}
.pagelinks .disabled
{
	/* text-decoration: line-through !important; */
}
.encserverdate { font-style: italic; color: #777; }


.encdb_imgpkr_chosen, .encdb_imgpkr_all, .encdb_imgpkr_upload
{
	border: 1px solid #999;
	background: rgba(255,255,255,0.70);
}
.encdb_imgpkr_image_block img		{ border: 1px solid #555; }
.encdb_imgpkr_viewmode_thumb		{ border: 1px solid #000; }

.encdb_filpkr_chosen, .encdb_filpkr_all, .encdb_filpkr_upload
{
	border: 1px solid #999;
	background: rgba(255,255,255,0.70);
}
.encdb_filpkr_file_block img		{ border: 1px solid #555; }
.encdb_filpkr_viewmode_thumb		{ border: 1px solid #000; }


.encmenu { border: 1px solid #888; box-shadow: 0 0 15px #777; margin: 2em auto; max-width: 400px; text-align: center; }
.encmenu div.linkrow, .encmenu div.text { display: block; padding: 5px; border: 0; color: #000 !important; text-decoration: none; }
.encmenu div.odd  { background: #f3f3f3; }
.encmenu div.even { background: #efefef; }
.encmenu div.first { border: 0; }
.encmenu a { color: black !important; text-decoration: none; }
.encmenu a:hover { color: #555 !important; text-decoration: underline; }
.encmenu .header { background: #e0e0e0; color: #333; font-weight: bold; padding: 12px; }
.encmenu div.text { font-weight: bold; }


/* not yet in use: */
.encdatepicker
{
	min-width: 150px;
	min-height: 100px;
	max-width: 250px;
	max-height: 200px;
	padding: 10px;

	border: 1px solid #777;
	background: #ddd;
}


.encpopup
{
	width: 100%;
	height: 100%;
	position: fixed;
	top: 0;
	left: 0;
	background: #ccc;   /* For ancient IE versions. */
	background: rgba(0, 0, 0, 0.3);	  /* Doesn't work in IE pre-v9, but that's prehistoric at this point. */
}
.encpopup_inner
{
	border: 1px solid #777;
	box-shadow: 0 0 15px #444;
	background: #eee;
	color: #333;
	padding: 10px;
	text-align: left;
	width: 300px;
	min-height: 80px;
	margin: 20% auto 0 auto;
}
.encpopup_buttons
{
	margin-top: 20px;
	text-align: right;
}


.enc_tablestyle_b { border-color: #bbb; }
.enc_tablestyle_b th { background: #e8e8e8; }
.enc_tablestyle_b tr.even { /* background: #f7f7f7; */ }
.enc_tablestyle_b tr { background: #f7f7f7; }
.enc_tablestyle_b tr { border-top-color: #bbb; }

.enc_box_a { border-color: #999; background: #eaeaea; color: #444; }


.encoverlayA
{
	position: fixed;
	bottom: 10px;
	left: 10px;
}
.encoverlayA_inner
{
	border: 1px solid #000;
	background: rgb(50, 50, 50); /* Fallback for IE pre-v9 which doesn't support rgba(). */
	background: rgba(20, 20, 20, 0.9);
	color: #fff;
	padding: 5px;
	text-align: left;
	width: 300px;
	min-height: 40px;
}
.encoverlayA_ctrl
{
	position: absolute;
	top: 2px;
	right: 2px;
	background: #000;
}
.encoverlayA_ctrl a
{
	color: #ddd;
	font-weight: bold;
	text-decoration: none;
	display: inline-block;
	padding: 1px 3px;
	outline: none;
}

#pw_strength { color: #777; }

#webconfig_page { color: #000; }
#webconfig_page .comment, .prefnote { color: #666; }
#webconfig_common_list .webconfig_pref { border-top: 1px solid #ccc; }
.webconfig_pref_stacked { border-top: 1px solid #ccc; }

.pref_code { color: #777; }

/* TODO: dark version of encapp inputs: */
.encapp input[type="text"], .encapp input[type="password"], .encapp textarea, .encapp select, .encapp input[type="button"] { border: 1px solid #aaa; background: #eee; color: black; padding: 0.3em; font: 1.1em/1.1em sans-serif; min-height: 1.1em; }
.encapp input[type="text"], .encapp textarea { }
.encapp select { padding: 0.2em; }
.encapp input[type="button"], .encapp input[type="submit"] { position: relative; padding: 0.4em 0.7em; font-size: 1em; color: #000; background-image: linear-gradient(#f8f8f8,#dddddd); border: 1px solid #999; border-radius: 1px; }
.encapp input[type="button"]:hover, .encapp input[type="submit"]:hover { color: #222; box-shadow: 0px 0px 4px #999; }
.encapp input[type="button"]:active, .encapp input[type="submit"]:active { top: 1px; }



`;









# PREFs Section C: Common Settings (used by multiple Encodable apps)
############################################################################
# Styling for dark theme:
#
$PREF{css_shared_dark} = qq`

#enc_server_info table, #enc_prefs_list table { text-align: left !important; }

.enc_tbl
{
	border: 1px solid #666;
	margin: 10px auto;
}
.enc_tbl table
{
	border-collapse: separate;
	border-spacing: 0;
	border: 0;
	background: #333;
	width: 100%;
	margin: 0;
	font-size: 8pt;
	text-align: center !important;
}
.enc_tbl table th
{
	padding: 9px;
	background: #555;
	color: #fff;
}
.enc_tbl td.verthead
{
	padding: 9px;
	background: #555;
	color: #fff;
	width: 30%;
	font-weight: bold !important;
}
.enc_tbl table th a, .enc_tbl td.verthead a, .enc_tbl td.verthead a:visited
{
	color: #fff !important;
	text-decoration: none;
}
.enc_tbl table td a, .enc_tbl table td a:visited
{
	color: #fff !important;
	border: 0;
}
.enc_tbl table td
{
	padding: 7px;
	border-bottom: 1px solid #222;
}
.enc_tbl table td.verthead, .enc_tbl table td.vertcell
{
	border-bottom: 1px solid #999;
}
/* For groups of related fields all in a row, make it easier to see that they're */
/* part of a group, by styling them together a bit differently than the others:  */
.enc_tbl table tr.group_odd td.verthead
{
	background: #406080;
	border-bottom: 1px solid #777;
}
.enc_tbl table tr.group_odd td.vertcell
{
	background: #dddddd;
	border-bottom: 1px solid #777;
}
.enc_tbl table tr
{
	border-bottom: 1px solid #222;
	background: #333;
}
.enc_tbl table tr.odd, .enc_tbl .db_readonly
{
	padding: 4px;
	background: #333;
}
.enc_tbl table tr.even
{
	padding: 4px;
	background: #333;
}
.enc_tbl table tr:hover
{
	background: #444;
}
.enc_tbl table tr:hover td.verthead
{
	background: #444;
}
.header_input_notes { color: #aaaaaa; }


.enc_tbl input.text
{
	width: 200px !important;
}
.enc_tbl input.text, .enc_tbl textarea, .enc_tbl input.srch_text
{
	border: 1px solid #666;
	background: #000;
	color: #bbb;
	padding: 3px;
}
.enc_tbl textarea.shorttext
{
	width: 300px;
	height: 50px;
}
.enc_tbl textarea.mediumtext
{
	width: 300px;
	height: 80px;
}
.enc_tbl textarea.longtext
{
	width: 300px;
	height: 200px;
}
.enc_tbl .readonly
{
	margin-left: 5px;
}
#database_deleter
{
	margin: 30px 0;
	padding: 0;
}
.database_header_note
{
	max-width: 500px;
	margin: 20px auto;
}
.enc_create_tbl table
{
	/* width: auto; */
}
.enc_create_tbl th, .enc_create_tbl td,
.enc_edit_tbl th, .enc_edit_tbl td
{
	text-align: left;
}
.enc_create_tbl td.button, .enc_edit_tbl td.button
{
	text-align: center;
}


.pagelinks
{
	/* font-size: 10pt; */
	cursor: default;
}
.pagelinks .links
{
	display: inline-block;
	margin-top: 10px;
	background: #444;
	border: 1px solid #666;
	padding: 5px;
}
.pagelinks .links span, .pagelinks .links a
{
	display: block;
	float: left;
	padding: 6px 11px;
	border-right: 1px solid #ccc;
}
.pagelinks .links span.last, .pagelinks .links a.last
{
	border-right: 0;
}
.pagelinks .disabled
{
	cursor: default;
	color: #999;
}
.pagelinks .current
{
	cursor: default;
	color: #999;
}
.pagelinks .links a
{
	color: #1E90FF;
	color: #333;
	text-decoration: none;
}
.pagelinks .links a:hover
{
	background: #333;
	text-decoration: none !important;
}
.pagelinks .text
{
	line-height: 16pt;
	vertical-align: middle;
	background: #444;
	display: inline-block;
	padding: 6px 12px;
	border: 1px solid #666;
}
.pagelinks .bookend
{
	display: none;

	font-size: 16pt;
	font-family: serif;
	color: #676767;
	margin: 0 5px;
	vertical-align: top;
}
.pagelinks .disabled
{
	/* text-decoration: line-through !important; */
}
.encserverdate { font-style: italic; color: #ddd; }


.encdb_imgpkr_chosen, .encdb_imgpkr_all, .encdb_imgpkr_upload
{
	border: 1px solid #999;
	background: rgba(255,255,255,0.70);
}
.encdb_imgpkr_image_block img		{ border: 1px solid #555; }
.encdb_imgpkr_viewmode_thumb		{ border: 1px solid #555; }

.encdb_filpkr_chosen, .encdb_filpkr_all, .encdb_filpkr_upload
{
	border: 1px solid #999;
	background: rgba(255,255,255,0.70);
}
.encdb_filpkr_file_block img		{ border: 1px solid #555; }
.encdb_filpkr_viewmode_thumb		{ border: 1px solid #555; }


.encmenu { border: 1px solid #666; margin: 2em auto; max-width: 400px; text-align: center; }
.encmenu div.linkrow, .encmenu div.text { display: block; padding: 5px; border: 0; color: #aaa !important; border-top: 1px solid #222; text-decoration: none; }
.encmenu div.odd  { background: #333; }
.encmenu div.even { background: #333; }
.encmenu div.first { border: 0; }
.encmenu a { color: #aaa !important; text-decoration: none; }
.encmenu a:hover { color: #555 !important; text-decoration: underline; }
.encmenu .header { background: #555; color: #fff; font-weight: bold; padding: 12px; }
.encmenu div.text { font-weight: bold; }


.enc_tablestyle_b { border-color: #666; }
.enc_tablestyle_b th { background: #555; color: #fff; }
.enc_tablestyle_b td { color: #fff; }
.enc_tablestyle_b tr.even { /* background: #f7f7f7; */ }
.enc_tablestyle_b tr { background: #333; border-top-color: #666; }

.enc_box_a { border-color: #666; background: #333; }

#webconfig_page { color: #ddd; }
#webconfig_page .comment, .prefnote { color: #777; }
#enc_webconfig .prefname, #enc_webconfig .prefvalue { border: 1px solid #666; background: #333; color: #bbb; }
#webconfig_buttons a { color: #222; }
#webconfig_buttons a:hover { color: #555; }

.pref_code { color: #888; }

`;
